%------------------------------------------------------------------------------
% File     : SLP025^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer GenClock problem prob_244__3244806_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : GenClock/prob_244__3244806_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  250 (   0 unit;  23 type;   0 defn)
%            Number of atoms       : 2585 ( 270 equality;1258 variable)
%            Maximal formula depth :   17 (   8 average)
%            Number of connectives : 1842 (  24   ~;  18   |;  30   &;1609   @)
%                                         (   0 <=>; 161  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   45 (  45   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   25 (  23   :;   0   =)
%            Number of variables   :  558 (   0 sgn; 534   !;   0   ?;  24   ^)
%                                         ( 558   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:29:49.880
%------------------------------------------------------------------------------
% Could-be-implicit typings (2)
thf(ty_n_t__Real__Oreal,type,(
    real: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

% Explicit typings (21)
thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OAdj,type,(
    genClo807607689le_Adj: nat > nat > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OIC,type,(
    genClo1160817912lle_IC: nat > nat > real > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_OPC,type,(
    genClo1161277105lle_PC: nat > real > real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_O_092_060rho_062,type,(
    genClo1144207539le_rho: real )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Ocorrect,type,(
    genClo1015804716orrect: nat > real > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Orho__bound1,type,(
    genClo2108747022bound1: ( nat > real > real ) > $o )).

thf(sy_c_GenClock__Mirabelle__bsvkzpgbls_Orho__bound2,type,(
    genClo2108747023bound2: ( nat > real > real ) > $o )).

thf(sy_c_Groups_Oabs__class_Oabs_001t__Real__Oreal,type,(
    abs_abs_real: real > real )).

thf(sy_c_Groups_Ominus__class_Ominus_001t__Real__Oreal,type,(
    minus_minus_real: real > real > real )).

thf(sy_c_Groups_Oone__class_Oone_001t__Real__Oreal,type,(
    one_one_real: real )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Real__Oreal,type,(
    plus_plus_real: real > real > real )).

thf(sy_c_Groups_Otimes__class_Otimes_001t__Real__Oreal,type,(
    times_times_real: real > real > real )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Real__Oreal,type,(
    zero_zero_real: real )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Real__Oreal,type,(
    ord_less_eq_real: real > real > $o )).

thf(sy_c_Orderings_Oorder__class_OGreatest_001t__Real__Oreal,type,(
    order_Greatest_real: ( real > $o ) > real )).

thf(sy_v_C,type,(
    c: nat > real > real )).

thf(sy_v_D,type,(
    d: nat > real > real )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_q,type,(
    q: nat )).

thf(sy_v_s,type,(
    s: real )).

thf(sy_v_t,type,(
    t: real )).

% Relevant facts (226)
thf(fact_0_rb2,axiom,(
    genClo2108747023bound2 @ d )).

% rb2
thf(fact_1_corr__q,axiom,(
    genClo1015804716orrect @ q @ t )).

% corr_q
thf(fact_2_ie,axiom,(
    ord_less_eq_real @ s @ t )).

% ie
thf(fact_3_rb1,axiom,(
    genClo2108747022bound1 @ c )).

% rb1
thf(fact_4_corr__p,axiom,(
    genClo1015804716orrect @ p @ t )).

% corr_p
thf(fact_5_PC__ie,axiom,(
    ord_less_eq_real @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) @ ( minus_minus_real @ ( c @ p @ t ) @ ( c @ p @ s ) ) )).

% PC_ie
thf(fact_6_rho__bound2__def,axiom,
    ( genClo2108747023bound2
    = ( ^ [C: nat > real > real] :
        ! [P: nat,S: real,T: real] :
          ( ( ( genClo1015804716orrect @ P @ T )
            & ( ord_less_eq_real @ S @ T ) )
         => ( ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ T @ S ) @ ( minus_minus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( C @ P @ T ) @ ( C @ P @ S ) ) ) ) ) )).

% rho_bound2_def
thf(fact_7_mult_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% mult.left_neutral
thf(fact_8_mult_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.right_neutral
thf(fact_9_order__refl,axiom,(
    ! [X: real] :
      ( ord_less_eq_real @ X @ X ) )).

% order_refl
thf(fact_10_rate__2,axiom,(
    ! [P2: nat,S2: real,T2: real] :
      ( ( ( genClo1015804716orrect @ P2 @ T2 )
        & ( ord_less_eq_real @ S2 @ T2 ) )
     => ( ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ T2 @ S2 ) @ ( minus_minus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( genClo1161277105lle_PC @ P2 @ T2 ) @ ( genClo1161277105lle_PC @ P2 @ S2 ) ) ) ) )).

% rate_2
thf(fact_11_Eq2,axiom,(
    ord_less_eq_real @ ( minus_minus_real @ ( minus_minus_real @ ( c @ p @ t ) @ ( c @ p @ s ) ) @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) ) @ ( minus_minus_real @ ( times_times_real @ ( minus_minus_real @ t @ s ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) ) )).

% Eq2
thf(fact_12_inf__period_I2_J,axiom,(
    ! [P3: real > $o,D: real,Q: real > $o] :
      ( ! [X2: real,K: real] :
          ( ( P3 @ X2 )
          = ( P3 @ ( minus_minus_real @ X2 @ ( times_times_real @ K @ D ) ) ) )
     => ( ! [X2: real,K: real] :
            ( ( Q @ X2 )
            = ( Q @ ( minus_minus_real @ X2 @ ( times_times_real @ K @ D ) ) ) )
       => ! [X3: real,K2: real] :
            ( ( ( P3 @ X3 )
              | ( Q @ X3 ) )
            = ( ( P3 @ ( minus_minus_real @ X3 @ ( times_times_real @ K2 @ D ) ) )
              | ( Q @ ( minus_minus_real @ X3 @ ( times_times_real @ K2 @ D ) ) ) ) ) ) ) )).

% inf_period(2)
thf(fact_13_inf__period_I1_J,axiom,(
    ! [P3: real > $o,D: real,Q: real > $o] :
      ( ! [X2: real,K: real] :
          ( ( P3 @ X2 )
          = ( P3 @ ( minus_minus_real @ X2 @ ( times_times_real @ K @ D ) ) ) )
     => ( ! [X2: real,K: real] :
            ( ( Q @ X2 )
            = ( Q @ ( minus_minus_real @ X2 @ ( times_times_real @ K @ D ) ) ) )
       => ! [X3: real,K2: real] :
            ( ( ( P3 @ X3 )
              & ( Q @ X3 ) )
            = ( ( P3 @ ( minus_minus_real @ X3 @ ( times_times_real @ K2 @ D ) ) )
              & ( Q @ ( minus_minus_real @ X3 @ ( times_times_real @ K2 @ D ) ) ) ) ) ) ) )).

% inf_period(1)
thf(fact_14_left__diff__distrib,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( minus_minus_real @ A @ B ) @ C2 )
      = ( minus_minus_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) )).

% left_diff_distrib
thf(fact_15_add__left__cancel,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C2 ) )
      = ( B = C2 ) ) )).

% add_left_cancel
thf(fact_16_add__right__cancel,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C2 @ A ) )
      = ( B = C2 ) ) )).

% add_right_cancel
thf(fact_17_add__le__cancel__right,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ C2 ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_18_add__le__cancel__left,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C2 @ A ) @ ( plus_plus_real @ C2 @ B ) )
      = ( ord_less_eq_real @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_19_add__diff__cancel__right_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_20_add__diff__cancel__right,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ C2 ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_21_add__diff__cancel__left_H,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_22_add__diff__cancel__left,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ C2 @ A ) @ ( plus_plus_real @ C2 @ B ) )
      = ( minus_minus_real @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_23_diff__add__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
      = A ) )).

% diff_add_cancel
thf(fact_24_add__diff__cancel,axiom,(
    ! [A: real,B: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel
thf(fact_25_le__add__diff__inverse2,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_26_le__add__diff__inverse,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( plus_plus_real @ B @ ( minus_minus_real @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_27_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C2 ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_28_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: real,J: real,K3: real,L: real] :
      ( ( ( I = J )
        & ( K3 = L ) )
     => ( ( plus_plus_real @ I @ K3 )
        = ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_29_group__cancel_Oadd1,axiom,(
    ! [A2: real,K3: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K3 @ A ) )
     => ( ( plus_plus_real @ A2 @ B )
        = ( plus_plus_real @ K3 @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_30_group__cancel_Oadd2,axiom,(
    ! [B2: real,K3: real,B: real,A: real] :
      ( ( B2
        = ( plus_plus_real @ K3 @ B ) )
     => ( ( plus_plus_real @ A @ B2 )
        = ( plus_plus_real @ K3 @ ( plus_plus_real @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_31_add_Oassoc,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C2 ) ) ) )).

% add.assoc
thf(fact_32_add_Oleft__cancel,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C2 ) )
      = ( B = C2 ) ) )).

% add.left_cancel
thf(fact_33_add_Oright__cancel,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C2 @ A ) )
      = ( B = C2 ) ) )).

% add.right_cancel
thf(fact_34_add_Ocommute,axiom,
    ( plus_plus_real
    = ( ^ [A3: real,B3: real] :
          ( plus_plus_real @ B3 @ A3 ) ) )).

% add.commute
thf(fact_35_add_Oleft__commute,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( plus_plus_real @ B @ ( plus_plus_real @ A @ C2 ) )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C2 ) ) ) )).

% add.left_commute
thf(fact_36_add__left__imp__eq,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ( plus_plus_real @ A @ B )
        = ( plus_plus_real @ A @ C2 ) )
     => ( B = C2 ) ) )).

% add_left_imp_eq
thf(fact_37_add__right__imp__eq,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ( plus_plus_real @ B @ A )
        = ( plus_plus_real @ C2 @ A ) )
     => ( B = C2 ) ) )).

% add_right_imp_eq
thf(fact_38_add__le__imp__le__right,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ C2 ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_39_add__le__imp__le__left,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ C2 @ A ) @ ( plus_plus_real @ C2 @ B ) )
     => ( ord_less_eq_real @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_40_add__right__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ C2 ) ) ) )).

% add_right_mono
thf(fact_41_add__left__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( plus_plus_real @ C2 @ A ) @ ( plus_plus_real @ C2 @ B ) ) ) )).

% add_left_mono
thf(fact_42_add__mono,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C2 @ D2 )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ D2 ) ) ) ) )).

% add_mono
thf(fact_43_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: real,J: real,K3: real,L: real] :
      ( ( ( ord_less_eq_real @ I @ J )
        & ( ord_less_eq_real @ K3 @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_44_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: real,J: real,K3: real,L: real] :
      ( ( ( I = J )
        & ( ord_less_eq_real @ K3 @ L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_45_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: real,J: real,K3: real,L: real] :
      ( ( ( ord_less_eq_real @ I @ J )
        & ( K3 = L ) )
     => ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ ( plus_plus_real @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_46_combine__common__factor,axiom,(
    ! [A: real,E: real,B: real,C2: real] :
      ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ C2 ) )
      = ( plus_plus_real @ ( times_times_real @ ( plus_plus_real @ A @ B ) @ E ) @ C2 ) ) )).

% combine_common_factor
thf(fact_47_distrib__right,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) )).

% distrib_right
thf(fact_48_distrib__left,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C2 ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C2 ) ) ) )).

% distrib_left
thf(fact_49_comm__semiring__class_Odistrib,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) )).

% comm_semiring_class.distrib
thf(fact_50_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ A @ ( plus_plus_real @ B @ C2 ) )
      = ( plus_plus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C2 ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_51_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_52_add__implies__diff,axiom,(
    ! [C2: real,B: real,A: real] :
      ( ( ( plus_plus_real @ C2 @ B )
        = A )
     => ( C2
        = ( minus_minus_real @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_53_diff__diff__add,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C2 )
      = ( minus_minus_real @ A @ ( plus_plus_real @ B @ C2 ) ) ) )).

% diff_diff_add
thf(fact_54_diff__add__eq__diff__diff__swap,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( minus_minus_real @ A @ ( plus_plus_real @ B @ C2 ) )
      = ( minus_minus_real @ ( minus_minus_real @ A @ C2 ) @ B ) ) )).

% diff_add_eq_diff_diff_swap
thf(fact_55_diff__add__eq,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ C2 )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C2 ) @ B ) ) )).

% diff_add_eq
thf(fact_56_diff__diff__eq2,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( minus_minus_real @ A @ ( minus_minus_real @ B @ C2 ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ C2 ) @ B ) ) )).

% diff_diff_eq2
thf(fact_57_add__diff__eq,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( plus_plus_real @ A @ ( minus_minus_real @ B @ C2 ) )
      = ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ C2 ) ) )).

% add_diff_eq
thf(fact_58_eq__diff__eq,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( A
        = ( minus_minus_real @ C2 @ B ) )
      = ( ( plus_plus_real @ A @ B )
        = C2 ) ) )).

% eq_diff_eq
thf(fact_59_diff__eq__eq,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = C2 )
      = ( A
        = ( plus_plus_real @ C2 @ B ) ) ) )).

% diff_eq_eq
thf(fact_60_group__cancel_Osub1,axiom,(
    ! [A2: real,K3: real,A: real,B: real] :
      ( ( A2
        = ( plus_plus_real @ K3 @ A ) )
     => ( ( minus_minus_real @ A2 @ B )
        = ( plus_plus_real @ K3 @ ( minus_minus_real @ A @ B ) ) ) ) )).

% group_cancel.sub1
thf(fact_61_add__le__add__imp__diff__le,axiom,(
    ! [I: real,K3: real,N: real,J: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ N )
     => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K3 ) )
       => ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ N )
         => ( ( ord_less_eq_real @ N @ ( plus_plus_real @ J @ K3 ) )
           => ( ord_less_eq_real @ ( minus_minus_real @ N @ K3 ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_62_add__le__imp__le__diff,axiom,(
    ! [I: real,K3: real,N: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ I @ K3 ) @ N )
     => ( ord_less_eq_real @ I @ ( minus_minus_real @ N @ K3 ) ) ) )).

% add_le_imp_le_diff
thf(fact_63_le__diff__eq,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( minus_minus_real @ C2 @ B ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ C2 ) ) )).

% le_diff_eq
thf(fact_64_diff__le__eq,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ ( minus_minus_real @ A @ B ) @ C2 )
      = ( ord_less_eq_real @ A @ ( plus_plus_real @ C2 @ B ) ) ) )).

% diff_le_eq
thf(fact_65_square__diff__square__factored,axiom,(
    ! [X: real,Y: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) )
      = ( times_times_real @ ( plus_plus_real @ X @ Y ) @ ( minus_minus_real @ X @ Y ) ) ) )).

% square_diff_square_factored
thf(fact_66_eq__add__iff2,axiom,(
    ! [A: real,E: real,C2: real,B: real,D2: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C2 )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D2 ) )
      = ( C2
        = ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D2 ) ) ) )).

% eq_add_iff2
thf(fact_67_eq__add__iff1,axiom,(
    ! [A: real,E: real,C2: real,B: real,D2: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ A @ E ) @ C2 )
        = ( plus_plus_real @ ( times_times_real @ B @ E ) @ D2 ) )
      = ( ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C2 )
        = D2 ) ) )).

% eq_add_iff1
thf(fact_68_PC__monotone,axiom,(
    ! [P2: nat,S2: real,T2: real] :
      ( ( ( genClo1015804716orrect @ P2 @ T2 )
        & ( ord_less_eq_real @ S2 @ T2 ) )
     => ( ord_less_eq_real @ ( genClo1161277105lle_PC @ P2 @ S2 ) @ ( genClo1161277105lle_PC @ P2 @ T2 ) ) ) )).

% PC_monotone
thf(fact_69_ordered__ring__class_Ole__add__iff2,axiom,(
    ! [A: real,E: real,C2: real,B: real,D2: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C2 ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D2 ) )
      = ( ord_less_eq_real @ C2 @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ B @ A ) @ E ) @ D2 ) ) ) )).

% ordered_ring_class.le_add_iff2
thf(fact_70_ordered__ring__class_Ole__add__iff1,axiom,(
    ! [A: real,E: real,C2: real,B: real,D2: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ A @ E ) @ C2 ) @ ( plus_plus_real @ ( times_times_real @ B @ E ) @ D2 ) )
      = ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ ( minus_minus_real @ A @ B ) @ E ) @ C2 ) @ D2 ) ) )).

% ordered_ring_class.le_add_iff1
thf(fact_71_square__diff__one__factored,axiom,(
    ! [X: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ X ) @ one_one_real )
      = ( times_times_real @ ( plus_plus_real @ X @ one_one_real ) @ ( minus_minus_real @ X @ one_one_real ) ) ) )).

% square_diff_one_factored
thf(fact_72_rate__1,axiom,(
    ! [P2: nat,S2: real,T2: real] :
      ( ( ( genClo1015804716orrect @ P2 @ T2 )
        & ( ord_less_eq_real @ S2 @ T2 ) )
     => ( ord_less_eq_real @ ( minus_minus_real @ ( genClo1161277105lle_PC @ P2 @ T2 ) @ ( genClo1161277105lle_PC @ P2 @ S2 ) ) @ ( times_times_real @ ( minus_minus_real @ T2 @ S2 ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) ) ) )).

% rate_1
thf(fact_73_dual__order_Oantisym,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_74_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [A3: real,B3: real] :
          ( ( ord_less_eq_real @ B3 @ A3 )
          & ( ord_less_eq_real @ A3 @ B3 ) ) ) )).

% dual_order.eq_iff
thf(fact_75_dual__order_Otrans,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C2 @ B )
       => ( ord_less_eq_real @ C2 @ A ) ) ) )).

% dual_order.trans
thf(fact_76_linorder__wlog,axiom,(
    ! [P3: real > real > $o,A: real,B: real] :
      ( ! [A4: real,B4: real] :
          ( ( ord_less_eq_real @ A4 @ B4 )
         => ( P3 @ A4 @ B4 ) )
     => ( ! [A4: real,B4: real] :
            ( ( P3 @ B4 @ A4 )
           => ( P3 @ A4 @ B4 ) )
       => ( P3 @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_77_dual__order_Orefl,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ A ) )).

% dual_order.refl
thf(fact_78_order__trans,axiom,(
    ! [X: real,Y: real,Z2: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ Z2 )
       => ( ord_less_eq_real @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_79_order__class_Oorder_Oantisym,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_80_ord__le__eq__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( B = C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% ord_le_eq_trans
thf(fact_81_ord__eq__le__trans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( A = B )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% ord_eq_le_trans
thf(fact_82_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [A3: real,B3: real] :
          ( ( ord_less_eq_real @ A3 @ B3 )
          & ( ord_less_eq_real @ B3 @ A3 ) ) ) )).

% order_class.order.eq_iff
thf(fact_83_antisym__conv,axiom,(
    ! [Y: real,X: real] :
      ( ( ord_less_eq_real @ Y @ X )
     => ( ( ord_less_eq_real @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_84_le__cases3,axiom,(
    ! [X: real,Y: real,Z2: real] :
      ( ( ( ord_less_eq_real @ X @ Y )
       => ~ ( ord_less_eq_real @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_real @ Y @ X )
         => ~ ( ord_less_eq_real @ X @ Z2 ) )
       => ( ( ( ord_less_eq_real @ X @ Z2 )
           => ~ ( ord_less_eq_real @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_real @ Z2 @ Y )
             => ~ ( ord_less_eq_real @ Y @ X ) )
           => ( ( ( ord_less_eq_real @ Y @ Z2 )
               => ~ ( ord_less_eq_real @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_real @ Z2 @ X )
                 => ~ ( ord_less_eq_real @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_85_order_Otrans,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ord_less_eq_real @ A @ C2 ) ) ) )).

% order.trans
thf(fact_86_le__cases,axiom,(
    ! [X: real,Y: real] :
      ( ~ ( ord_less_eq_real @ X @ Y )
     => ( ord_less_eq_real @ Y @ X ) ) )).

% le_cases
thf(fact_87_eq__refl,axiom,(
    ! [X: real,Y: real] :
      ( ( X = Y )
     => ( ord_less_eq_real @ X @ Y ) ) )).

% eq_refl
thf(fact_88_linear,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
      | ( ord_less_eq_real @ Y @ X ) ) )).

% linear
thf(fact_89_antisym,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ Y )
     => ( ( ord_less_eq_real @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_90_eq__iff,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [X4: real,Y3: real] :
          ( ( ord_less_eq_real @ X4 @ Y3 )
          & ( ord_less_eq_real @ Y3 @ X4 ) ) ) )).

% eq_iff
thf(fact_91_ord__le__eq__subst,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ( F @ B )
          = C2 )
       => ( ! [X2: real,Y4: real] :
              ( ( ord_less_eq_real @ X2 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X2 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% ord_le_eq_subst
thf(fact_92_ord__eq__le__subst,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X2: real,Y4: real] :
              ( ( ord_less_eq_real @ X2 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X2 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_93_order__subst2,axiom,(
    ! [A: real,B: real,F: real > real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ ( F @ B ) @ C2 )
       => ( ! [X2: real,Y4: real] :
              ( ( ord_less_eq_real @ X2 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X2 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ ( F @ A ) @ C2 ) ) ) ) )).

% order_subst2
thf(fact_94_order__subst1,axiom,(
    ! [A: real,F: real > real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ ( F @ B ) )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ! [X2: real,Y4: real] :
              ( ( ord_less_eq_real @ X2 @ Y4 )
             => ( ord_less_eq_real @ ( F @ X2 ) @ ( F @ Y4 ) ) )
         => ( ord_less_eq_real @ A @ ( F @ C2 ) ) ) ) ) )).

% order_subst1
thf(fact_95_mult_Oleft__commute,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( times_times_real @ B @ ( times_times_real @ A @ C2 ) )
      = ( times_times_real @ A @ ( times_times_real @ B @ C2 ) ) ) )).

% mult.left_commute
thf(fact_96_mult_Ocommute,axiom,
    ( times_times_real
    = ( ^ [A3: real,B3: real] :
          ( times_times_real @ B3 @ A3 ) ) )).

% mult.commute
thf(fact_97_mult_Oassoc,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C2 )
      = ( times_times_real @ A @ ( times_times_real @ B @ C2 ) ) ) )).

% mult.assoc
thf(fact_98_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ ( times_times_real @ A @ B ) @ C2 )
      = ( times_times_real @ A @ ( times_times_real @ B @ C2 ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_99_one__reorient,axiom,(
    ! [X: real] :
      ( ( one_one_real = X )
      = ( X = one_one_real ) ) )).

% one_reorient
thf(fact_100_diff__right__commute,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( minus_minus_real @ ( minus_minus_real @ A @ C2 ) @ B )
      = ( minus_minus_real @ ( minus_minus_real @ A @ B ) @ C2 ) ) )).

% diff_right_commute
thf(fact_101_diff__eq__diff__eq,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C2 @ D2 ) )
     => ( ( A = B )
        = ( C2 = D2 ) ) ) )).

% diff_eq_diff_eq
thf(fact_102_rho__bound1__def,axiom,
    ( genClo2108747022bound1
    = ( ^ [C: nat > real > real] :
        ! [P: nat,S: real,T: real] :
          ( ( ( genClo1015804716orrect @ P @ T )
            & ( ord_less_eq_real @ S @ T ) )
         => ( ord_less_eq_real @ ( minus_minus_real @ ( C @ P @ T ) @ ( C @ P @ S ) ) @ ( times_times_real @ ( minus_minus_real @ T @ S ) @ ( plus_plus_real @ one_one_real @ genClo1144207539le_rho ) ) ) ) ) )).

% rho_bound1_def
thf(fact_103_correct__closed,axiom,(
    ! [P2: nat,S2: real,T2: real] :
      ( ( ( ord_less_eq_real @ S2 @ T2 )
        & ( genClo1015804716orrect @ P2 @ T2 ) )
     => ( genClo1015804716orrect @ P2 @ S2 ) ) )).

% correct_closed
thf(fact_104_diff__eq__diff__less__eq,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ( minus_minus_real @ A @ B )
        = ( minus_minus_real @ C2 @ D2 ) )
     => ( ( ord_less_eq_real @ A @ B )
        = ( ord_less_eq_real @ C2 @ D2 ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_105_diff__right__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ord_less_eq_real @ ( minus_minus_real @ A @ C2 ) @ ( minus_minus_real @ B @ C2 ) ) ) )).

% diff_right_mono
thf(fact_106_diff__left__mono,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ord_less_eq_real @ ( minus_minus_real @ C2 @ A ) @ ( minus_minus_real @ C2 @ B ) ) ) )).

% diff_left_mono
thf(fact_107_diff__mono,axiom,(
    ! [A: real,B: real,D2: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ D2 @ C2 )
       => ( ord_less_eq_real @ ( minus_minus_real @ A @ C2 ) @ ( minus_minus_real @ B @ D2 ) ) ) ) )).

% diff_mono
thf(fact_108_mult_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ one_one_real )
      = A ) )).

% mult.comm_neutral
thf(fact_109_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: real] :
      ( ( times_times_real @ one_one_real @ A )
      = A ) )).

% comm_monoid_mult_class.mult_1
thf(fact_110_right__diff__distrib_H,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C2 ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C2 ) ) ) )).

% right_diff_distrib'
thf(fact_111_left__diff__distrib_H,axiom,(
    ! [B: real,C2: real,A: real] :
      ( ( times_times_real @ ( minus_minus_real @ B @ C2 ) @ A )
      = ( minus_minus_real @ ( times_times_real @ B @ A ) @ ( times_times_real @ C2 @ A ) ) ) )).

% left_diff_distrib'
thf(fact_112_right__diff__distrib,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( times_times_real @ A @ ( minus_minus_real @ B @ C2 ) )
      = ( minus_minus_real @ ( times_times_real @ A @ B ) @ ( times_times_real @ A @ C2 ) ) ) )).

% right_diff_distrib
thf(fact_113_Eq1,axiom,
    ( ( abs_abs_real @ ( minus_minus_real @ ( minus_minus_real @ ( c @ p @ t ) @ ( c @ p @ s ) ) @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) ) )
    = ( minus_minus_real @ ( minus_minus_real @ ( c @ p @ t ) @ ( c @ p @ s ) ) @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) ) )).

% Eq1
thf(fact_114_mult__diff__mult,axiom,(
    ! [X: real,Y: real,A: real,B: real] :
      ( ( minus_minus_real @ ( times_times_real @ X @ Y ) @ ( times_times_real @ A @ B ) )
      = ( plus_plus_real @ ( times_times_real @ X @ ( minus_minus_real @ Y @ B ) ) @ ( times_times_real @ ( minus_minus_real @ X @ A ) @ B ) ) ) )).

% mult_diff_mult
thf(fact_115_eq__diff__eq_H,axiom,(
    ! [X: real,Y: real,Z2: real] :
      ( ( X
        = ( minus_minus_real @ Y @ Z2 ) )
      = ( Y
        = ( plus_plus_real @ X @ Z2 ) ) ) )).

% eq_diff_eq'
thf(fact_116_add__diff__add,axiom,(
    ! [A: real,C2: real,B: real,D2: real] :
      ( ( minus_minus_real @ ( plus_plus_real @ A @ C2 ) @ ( plus_plus_real @ B @ D2 ) )
      = ( plus_plus_real @ ( minus_minus_real @ A @ B ) @ ( minus_minus_real @ C2 @ D2 ) ) ) )).

% add_diff_add
thf(fact_117_crossproduct__noteq,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ( A != B )
        & ( C2 != D2 ) )
      = ( ( plus_plus_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ D2 ) )
       != ( plus_plus_real @ ( times_times_real @ A @ D2 ) @ ( times_times_real @ B @ C2 ) ) ) ) )).

% crossproduct_noteq
thf(fact_118_crossproduct__eq,axiom,(
    ! [W: real,Y: real,X: real,Z2: real] :
      ( ( ( plus_plus_real @ ( times_times_real @ W @ Y ) @ ( times_times_real @ X @ Z2 ) )
        = ( plus_plus_real @ ( times_times_real @ W @ Z2 ) @ ( times_times_real @ X @ Y ) ) )
      = ( ( W = X )
        | ( Y = Z2 ) ) ) )).

% crossproduct_eq
thf(fact_119_le__numeral__extra_I4_J,axiom,(
    ord_less_eq_real @ one_one_real @ one_one_real )).

% le_numeral_extra(4)
thf(fact_120_IClock,axiom,(
    ! [P2: nat,T2: real,I2: nat] :
      ( ( genClo1015804716orrect @ P2 @ T2 )
     => ( ( genClo1160817912lle_IC @ P2 @ I2 @ T2 )
        = ( plus_plus_real @ ( genClo1161277105lle_PC @ P2 @ T2 ) @ ( genClo807607689le_Adj @ P2 @ I2 ) ) ) ) )).

% IClock
thf(fact_121_convex__bound__le,axiom,(
    ! [X: real,A: real,Y: real,U: real,V: real] :
      ( ( ord_less_eq_real @ X @ A )
     => ( ( ord_less_eq_real @ Y @ A )
       => ( ( ord_less_eq_real @ zero_zero_real @ U )
         => ( ( ord_less_eq_real @ zero_zero_real @ V )
           => ( ( ( plus_plus_real @ U @ V )
                = one_one_real )
             => ( ord_less_eq_real @ ( plus_plus_real @ ( times_times_real @ U @ X ) @ ( times_times_real @ V @ Y ) ) @ A ) ) ) ) ) ) )).

% convex_bound_le
thf(fact_122_Greatest__equality,axiom,(
    ! [P3: real > $o,X: real] :
      ( ( P3 @ X )
     => ( ! [Y4: real] :
            ( ( P3 @ Y4 )
           => ( ord_less_eq_real @ Y4 @ X ) )
       => ( ( order_Greatest_real @ P3 )
          = X ) ) ) )).

% Greatest_equality
thf(fact_123_abs__abs,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_abs
thf(fact_124_abs__idempotent,axiom,(
    ! [A: real] :
      ( ( abs_abs_real @ ( abs_abs_real @ A ) )
      = ( abs_abs_real @ A ) ) )).

% abs_idempotent
thf(fact_125_mult__zero__left,axiom,(
    ! [A: real] :
      ( ( times_times_real @ zero_zero_real @ A )
      = zero_zero_real ) )).

% mult_zero_left
thf(fact_126_mult__zero__right,axiom,(
    ! [A: real] :
      ( ( times_times_real @ A @ zero_zero_real )
      = zero_zero_real ) )).

% mult_zero_right
thf(fact_127_mult__eq__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
      = ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% mult_eq_0_iff
thf(fact_128_mult__cancel__left,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( ( times_times_real @ C2 @ A )
        = ( times_times_real @ C2 @ B ) )
      = ( ( C2 = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_left
thf(fact_129_mult__cancel__right,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( ( times_times_real @ A @ C2 )
        = ( times_times_real @ B @ C2 ) )
      = ( ( C2 = zero_zero_real )
        | ( A = B ) ) ) )).

% mult_cancel_right
thf(fact_130_add__cancel__right__right,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ A @ B ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_right
thf(fact_131_add__cancel__right__left,axiom,(
    ! [A: real,B: real] :
      ( ( A
        = ( plus_plus_real @ B @ A ) )
      = ( B = zero_zero_real ) ) )).

% add_cancel_right_left
thf(fact_132_add__cancel__left__right,axiom,(
    ! [A: real,B: real] :
      ( ( ( plus_plus_real @ A @ B )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_right
thf(fact_133_add__cancel__left__left,axiom,(
    ! [B: real,A: real] :
      ( ( ( plus_plus_real @ B @ A )
        = A )
      = ( B = zero_zero_real ) ) )).

% add_cancel_left_left
thf(fact_134_double__zero__sym,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( plus_plus_real @ A @ A ) )
      = ( A = zero_zero_real ) ) )).

% double_zero_sym
thf(fact_135_double__zero,axiom,(
    ! [A: real] :
      ( ( ( plus_plus_real @ A @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% double_zero
thf(fact_136_add_Oright__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.right_neutral
thf(fact_137_add_Oleft__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.left_neutral
thf(fact_138_diff__self,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% diff_self
thf(fact_139_diff__0__right,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_0_right
thf(fact_140_diff__zero,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ zero_zero_real )
      = A ) )).

% diff_zero
thf(fact_141_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: real] :
      ( ( minus_minus_real @ A @ A )
      = zero_zero_real ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_142_abs__0,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_0
thf(fact_143_abs__0__eq,axiom,(
    ! [A: real] :
      ( ( zero_zero_real
        = ( abs_abs_real @ A ) )
      = ( A = zero_zero_real ) ) )).

% abs_0_eq
thf(fact_144_abs__eq__0,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0
thf(fact_145_abs__zero,axiom,
    ( ( abs_abs_real @ zero_zero_real )
    = zero_zero_real )).

% abs_zero
thf(fact_146_abs__mult__self__eq,axiom,(
    ! [A: real] :
      ( ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ A ) )
      = ( times_times_real @ A @ A ) ) )).

% abs_mult_self_eq
thf(fact_147_abs__add__abs,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) )
      = ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_add_abs
thf(fact_148_abs__1,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_1
thf(fact_149_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_150_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ A ) @ zero_zero_real )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_151_le__add__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ B @ A ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel2
thf(fact_152_le__add__same__cancel1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ ( plus_plus_real @ A @ B ) )
      = ( ord_less_eq_real @ zero_zero_real @ B ) ) )).

% le_add_same_cancel1
thf(fact_153_add__le__same__cancel2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel2
thf(fact_154_add__le__same__cancel1,axiom,(
    ! [B: real,A: real] :
      ( ( ord_less_eq_real @ ( plus_plus_real @ B @ A ) @ B )
      = ( ord_less_eq_real @ A @ zero_zero_real ) ) )).

% add_le_same_cancel1
thf(fact_155_diff__ge__0__iff__ge,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( minus_minus_real @ A @ B ) )
      = ( ord_less_eq_real @ B @ A ) ) )).

% diff_ge_0_iff_ge
thf(fact_156_mult__cancel__left1,axiom,(
    ! [C2: real,B: real] :
      ( ( C2
        = ( times_times_real @ C2 @ B ) )
      = ( ( C2 = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_left1
thf(fact_157_mult__cancel__left2,axiom,(
    ! [C2: real,A: real] :
      ( ( ( times_times_real @ C2 @ A )
        = C2 )
      = ( ( C2 = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_left2
thf(fact_158_mult__cancel__right1,axiom,(
    ! [C2: real,B: real] :
      ( ( C2
        = ( times_times_real @ B @ C2 ) )
      = ( ( C2 = zero_zero_real )
        | ( B = one_one_real ) ) ) )).

% mult_cancel_right1
thf(fact_159_mult__cancel__right2,axiom,(
    ! [A: real,C2: real] :
      ( ( ( times_times_real @ A @ C2 )
        = C2 )
      = ( ( C2 = zero_zero_real )
        | ( A = one_one_real ) ) ) )).

% mult_cancel_right2
thf(fact_160_diff__numeral__special_I9_J,axiom,
    ( ( minus_minus_real @ one_one_real @ one_one_real )
    = zero_zero_real )).

% diff_numeral_special(9)
thf(fact_161_abs__le__zero__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_le_zero_iff
thf(fact_162_abs__le__self__iff,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ A )
      = ( ord_less_eq_real @ zero_zero_real @ A ) ) )).

% abs_le_self_iff
thf(fact_163_abs__of__nonneg,axiom,(
    ! [A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( abs_abs_real @ A )
        = A ) ) )).

% abs_of_nonneg
thf(fact_164_zero__reorient,axiom,(
    ! [X: real] :
      ( ( zero_zero_real = X )
      = ( X = zero_zero_real ) ) )).

% zero_reorient
thf(fact_165_abs__eq__0__iff,axiom,(
    ! [A: real] :
      ( ( ( abs_abs_real @ A )
        = zero_zero_real )
      = ( A = zero_zero_real ) ) )).

% abs_eq_0_iff
thf(fact_166_abs__ge__zero,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( abs_abs_real @ A ) ) )).

% abs_ge_zero
thf(fact_167_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_real @ zero_zero_real @ zero_zero_real )).

% le_numeral_extra(3)
thf(fact_168_add__0__iff,axiom,(
    ! [B: real,A: real] :
      ( ( B
        = ( plus_plus_real @ B @ A ) )
      = ( A = zero_zero_real ) ) )).

% add_0_iff
thf(fact_169_abs__mult__pos,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( times_times_real @ ( abs_abs_real @ Y ) @ X )
        = ( abs_abs_real @ ( times_times_real @ Y @ X ) ) ) ) )).

% abs_mult_pos
thf(fact_170_abs__eq__mult,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          | ( ord_less_eq_real @ A @ zero_zero_real ) )
        & ( ( ord_less_eq_real @ zero_zero_real @ B )
          | ( ord_less_eq_real @ B @ zero_zero_real ) ) )
     => ( ( abs_abs_real @ ( times_times_real @ A @ B ) )
        = ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) ) )).

% abs_eq_mult
thf(fact_171_abs__le__D1,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ A ) @ B )
     => ( ord_less_eq_real @ A @ B ) ) )).

% abs_le_D1
thf(fact_172_abs__ge__self,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ A @ ( abs_abs_real @ A ) ) )).

% abs_ge_self
thf(fact_173_abs__mult,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( times_times_real @ A @ B ) )
      = ( times_times_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_mult
thf(fact_174_abs__one,axiom,
    ( ( abs_abs_real @ one_one_real )
    = one_one_real )).

% abs_one
thf(fact_175_abs__minus__commute,axiom,(
    ! [A: real,B: real] :
      ( ( abs_abs_real @ ( minus_minus_real @ A @ B ) )
      = ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_minus_commute
thf(fact_176_mult__not__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
       != zero_zero_real )
     => ( ( A != zero_zero_real )
        & ( B != zero_zero_real ) ) ) )).

% mult_not_zero
thf(fact_177_divisors__zero,axiom,(
    ! [A: real,B: real] :
      ( ( ( times_times_real @ A @ B )
        = zero_zero_real )
     => ( ( A = zero_zero_real )
        | ( B = zero_zero_real ) ) ) )).

% divisors_zero
thf(fact_178_no__zero__divisors,axiom,(
    ! [A: real,B: real] :
      ( ( A != zero_zero_real )
     => ( ( B != zero_zero_real )
       => ( ( times_times_real @ A @ B )
         != zero_zero_real ) ) ) )).

% no_zero_divisors
thf(fact_179_mult__left__cancel,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( C2 != zero_zero_real )
     => ( ( ( times_times_real @ C2 @ A )
          = ( times_times_real @ C2 @ B ) )
        = ( A = B ) ) ) )).

% mult_left_cancel
thf(fact_180_mult__right__cancel,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( C2 != zero_zero_real )
     => ( ( ( times_times_real @ A @ C2 )
          = ( times_times_real @ B @ C2 ) )
        = ( A = B ) ) ) )).

% mult_right_cancel
thf(fact_181_add_Ogroup__left__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% add.group_left_neutral
thf(fact_182_add_Ocomm__neutral,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ A @ zero_zero_real )
      = A ) )).

% add.comm_neutral
thf(fact_183_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: real] :
      ( ( plus_plus_real @ zero_zero_real @ A )
      = A ) )).

% comm_monoid_add_class.add_0
thf(fact_184_zero__neq__one,axiom,(
    zero_zero_real != one_one_real )).

% zero_neq_one
thf(fact_185_eq__iff__diff__eq__0,axiom,
    ( ( ^ [Y2: real,Z: real] : ( Y2 = Z ) )
    = ( ^ [A3: real,B3: real] :
          ( ( minus_minus_real @ A3 @ B3 )
          = zero_zero_real ) ) )).

% eq_iff_diff_eq_0
thf(fact_186_add__scale__eq__noteq,axiom,(
    ! [R: real,A: real,B: real,C2: real,D2: real] :
      ( ( R != zero_zero_real )
     => ( ( ( A = B )
          & ( C2 != D2 ) )
       => ( ( plus_plus_real @ A @ ( times_times_real @ R @ C2 ) )
         != ( plus_plus_real @ B @ ( times_times_real @ R @ D2 ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_187_abs__triangle__ineq,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( plus_plus_real @ A @ B ) ) @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_triangle_ineq
thf(fact_188_abs__triangle__ineq2,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq2
thf(fact_189_abs__triangle__ineq3,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) ) )).

% abs_triangle_ineq3
thf(fact_190_abs__triangle__ineq2__sym,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( minus_minus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ A ) ) ) )).

% abs_triangle_ineq2_sym
thf(fact_191_sin__bound__lemma,axiom,(
    ! [X: real,Y: real,U: real,V: real] :
      ( ( X = Y )
     => ( ( ord_less_eq_real @ ( abs_abs_real @ U ) @ V )
       => ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( plus_plus_real @ X @ U ) @ Y ) ) @ V ) ) ) )).

% sin_bound_lemma
thf(fact_192_mult__mono,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C2 @ D2 )
       => ( ( ord_less_eq_real @ zero_zero_real @ B )
         => ( ( ord_less_eq_real @ zero_zero_real @ C2 )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ D2 ) ) ) ) ) ) )).

% mult_mono
thf(fact_193_mult__mono_H,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ C2 @ D2 )
       => ( ( ord_less_eq_real @ zero_zero_real @ A )
         => ( ( ord_less_eq_real @ zero_zero_real @ C2 )
           => ( ord_less_eq_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ D2 ) ) ) ) ) ) )).

% mult_mono'
thf(fact_194_zero__le__square,axiom,(
    ! [A: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ A ) ) )).

% zero_le_square
thf(fact_195_split__mult__pos__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) )
     => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) )).

% split_mult_pos_le
thf(fact_196_mult__left__mono__neg,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C2 @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ C2 @ A ) @ ( times_times_real @ C2 @ B ) ) ) ) )).

% mult_left_mono_neg
thf(fact_197_mult__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_198_mult__left__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C2 )
       => ( ord_less_eq_real @ ( times_times_real @ C2 @ A ) @ ( times_times_real @ C2 @ B ) ) ) ) )).

% mult_left_mono
thf(fact_199_mult__right__mono__neg,axiom,(
    ! [B: real,A: real,C2: real] :
      ( ( ord_less_eq_real @ B @ A )
     => ( ( ord_less_eq_real @ C2 @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) ) )).

% mult_right_mono_neg
thf(fact_200_mult__right__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C2 )
       => ( ord_less_eq_real @ ( times_times_real @ A @ C2 ) @ ( times_times_real @ B @ C2 ) ) ) ) )).

% mult_right_mono
thf(fact_201_mult__le__0__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) ) ) )).

% mult_le_0_iff
thf(fact_202_split__mult__neg__le,axiom,(
    ! [A: real,B: real] :
      ( ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ B @ zero_zero_real ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ zero_zero_real @ B ) ) )
     => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) )).

% split_mult_neg_le
thf(fact_203_mult__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_204_mult__nonneg__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos
thf(fact_205_mult__nonpos__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ ( times_times_real @ A @ B ) @ zero_zero_real ) ) ) )).

% mult_nonpos_nonneg
thf(fact_206_mult__nonneg__nonpos2,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( times_times_real @ B @ A ) @ zero_zero_real ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_207_zero__le__mult__iff,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ ( times_times_real @ A @ B ) )
      = ( ( ( ord_less_eq_real @ zero_zero_real @ A )
          & ( ord_less_eq_real @ zero_zero_real @ B ) )
        | ( ( ord_less_eq_real @ A @ zero_zero_real )
          & ( ord_less_eq_real @ B @ zero_zero_real ) ) ) ) )).

% zero_le_mult_iff
thf(fact_208_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ A @ B )
     => ( ( ord_less_eq_real @ zero_zero_real @ C2 )
       => ( ord_less_eq_real @ ( times_times_real @ C2 @ A ) @ ( times_times_real @ C2 @ B ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_209_add__nonpos__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ X @ zero_zero_real )
     => ( ( ord_less_eq_real @ Y @ zero_zero_real )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonpos_eq_0_iff
thf(fact_210_add__nonneg__eq__0__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ( plus_plus_real @ X @ Y )
            = zero_zero_real )
          = ( ( X = zero_zero_real )
            & ( Y = zero_zero_real ) ) ) ) ) )).

% add_nonneg_eq_0_iff
thf(fact_211_add__nonpos__nonpos,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ B @ zero_zero_real )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ B ) @ zero_zero_real ) ) ) )).

% add_nonpos_nonpos
thf(fact_212_add__nonneg__nonneg,axiom,(
    ! [A: real,B: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ zero_zero_real @ B )
       => ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ A @ B ) ) ) ) )).

% add_nonneg_nonneg
thf(fact_213_add__increasing2,axiom,(
    ! [C2: real,B: real,A: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ C2 )
     => ( ( ord_less_eq_real @ B @ A )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C2 ) ) ) ) )).

% add_increasing2
thf(fact_214_add__decreasing2,axiom,(
    ! [C2: real,A: real,B: real] :
      ( ( ord_less_eq_real @ C2 @ zero_zero_real )
     => ( ( ord_less_eq_real @ A @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ B ) ) ) )).

% add_decreasing2
thf(fact_215_add__increasing,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ A )
     => ( ( ord_less_eq_real @ B @ C2 )
       => ( ord_less_eq_real @ B @ ( plus_plus_real @ A @ C2 ) ) ) ) )).

% add_increasing
thf(fact_216_add__decreasing,axiom,(
    ! [A: real,C2: real,B: real] :
      ( ( ord_less_eq_real @ A @ zero_zero_real )
     => ( ( ord_less_eq_real @ C2 @ B )
       => ( ord_less_eq_real @ ( plus_plus_real @ A @ C2 ) @ B ) ) ) )).

% add_decreasing
thf(fact_217_zero__le__one,axiom,(
    ord_less_eq_real @ zero_zero_real @ one_one_real )).

% zero_le_one
thf(fact_218_not__one__le__zero,axiom,(
    ~ ( ord_less_eq_real @ one_one_real @ zero_zero_real ) )).

% not_one_le_zero
thf(fact_219_le__iff__diff__le__0,axiom,
    ( ord_less_eq_real
    = ( ^ [A3: real,B3: real] :
          ( ord_less_eq_real @ ( minus_minus_real @ A3 @ B3 ) @ zero_zero_real ) ) )).

% le_iff_diff_le_0
thf(fact_220_abs__diff__le__iff,axiom,(
    ! [X: real,A: real,R: real] :
      ( ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ X @ A ) ) @ R )
      = ( ( ord_less_eq_real @ ( minus_minus_real @ A @ R ) @ X )
        & ( ord_less_eq_real @ X @ ( plus_plus_real @ A @ R ) ) ) ) )).

% abs_diff_le_iff
thf(fact_221_abs__triangle__ineq4,axiom,(
    ! [A: real,B: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ A @ B ) ) @ ( plus_plus_real @ ( abs_abs_real @ A ) @ ( abs_abs_real @ B ) ) ) )).

% abs_triangle_ineq4
thf(fact_222_abs__diff__triangle__ineq,axiom,(
    ! [A: real,B: real,C2: real,D2: real] :
      ( ord_less_eq_real @ ( abs_abs_real @ ( minus_minus_real @ ( plus_plus_real @ A @ B ) @ ( plus_plus_real @ C2 @ D2 ) ) ) @ ( plus_plus_real @ ( abs_abs_real @ ( minus_minus_real @ A @ C2 ) ) @ ( abs_abs_real @ ( minus_minus_real @ B @ D2 ) ) ) ) )).

% abs_diff_triangle_ineq
thf(fact_223_is__num__normalize_I1_J,axiom,(
    ! [A: real,B: real,C2: real] :
      ( ( plus_plus_real @ ( plus_plus_real @ A @ B ) @ C2 )
      = ( plus_plus_real @ A @ ( plus_plus_real @ B @ C2 ) ) ) )).

% is_num_normalize(1)
thf(fact_224_sum__squares__ge__zero,axiom,(
    ! [X: real,Y: real] :
      ( ord_less_eq_real @ zero_zero_real @ ( plus_plus_real @ ( times_times_real @ X @ X ) @ ( times_times_real @ Y @ Y ) ) ) )).

% sum_squares_ge_zero
thf(fact_225_mult__left__le__one__le,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less_eq_real @ zero_zero_real @ X )
     => ( ( ord_less_eq_real @ zero_zero_real @ Y )
       => ( ( ord_less_eq_real @ Y @ one_one_real )
         => ( ord_less_eq_real @ ( times_times_real @ Y @ X ) @ X ) ) ) ) )).

% mult_left_le_one_le

% Conjectures (1)
thf(conj_0,conjecture,(
    ord_less_eq_real @ ( times_times_real @ ( minus_minus_real @ t @ s ) @ ( minus_minus_real @ one_one_real @ genClo1144207539le_rho ) ) @ ( minus_minus_real @ ( d @ q @ t ) @ ( d @ q @ s ) ) )).

%------------------------------------------------------------------------------
