%------------------------------------------------------------------------------
% File     : SLP051^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer ListInf problem prob_565__5417616_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : ListInf/prob_565__5417616_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  244 (   0 unit;  18 type;   0 defn)
%            Number of atoms       : 2508 ( 180 equality;1515 variable)
%            Maximal formula depth :   14 (   8 average)
%            Number of connectives : 1978 (  56   ~;  10   |;  22   &;1598   @)
%                                         (   0 <=>; 292  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   41 (  41   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   20 (  18   :;   0   =)
%            Number of variables   :  681 (   0 sgn; 632   !;  10   ?;  39   ^)
%                                         ( 681   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:32:53.948
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__List__Olist_It__Nat__Onat_J,type,(
    list_nat: $tType )).

thf(ty_n_t__List__Olist_Itf__a_J,type,(
    list_a: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_tf__a,type,(
    a: $tType )).

% Explicit typings (14)
thf(sy_c_Groups_Ominus__class_Ominus_001t__Nat__Onat,type,(
    minus_minus_nat: nat > nat > nat )).

thf(sy_c_Groups_Oplus__class_Oplus_001t__Nat__Onat,type,(
    plus_plus_nat: nat > nat > nat )).

thf(sy_c_List2_Olist__desc_001t__Nat__Onat,type,(
    list_desc_nat: list_nat > $o )).

thf(sy_c_List2_Olist__strict__asc_001t__Nat__Onat,type,(
    list_strict_asc_nat: list_nat > $o )).

thf(sy_c_List_Onth_001t__Nat__Onat,type,(
    nth_nat: list_nat > nat > nat )).

thf(sy_c_List_Onth_001tf__a,type,(
    nth_a: list_a > nat > a )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_It__Nat__Onat_J,type,(
    size_size_list_nat: list_nat > nat )).

thf(sy_c_Nat_Osize__class_Osize_001t__List__Olist_Itf__a_J,type,(
    size_size_list_a: list_a > nat )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_v_f,type,(
    f: nat > a )).

thf(sy_v_g,type,(
    g: nat > a )).

thf(sy_v_xs,type,(
    xs: list_a )).

thf(sy_v_ys,type,(
    ys: list_a )).

% Relevant facts (223)
thf(fact_0_Nat_Oadd__diff__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K ) ) ) )).

% Nat.add_diff_assoc
thf(fact_1_Nat_Oadd__diff__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K ) ) ) )).

% Nat.add_diff_assoc2
thf(fact_2_Util__Nat_Odiff__diff__right,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Util_Nat.diff_diff_right
thf(fact_3_le__add__diff__inverse,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% le_add_diff_inverse
thf(fact_4_le__add__diff__inverse2,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ A @ B ) @ B )
        = A ) ) )).

% le_add_diff_inverse2
thf(fact_5_diff__diff__left,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ I @ ( plus_plus_nat @ J @ K ) ) ) )).

% diff_diff_left
thf(fact_6_diff__diff__cancel,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ N )
     => ( ( minus_minus_nat @ N @ ( minus_minus_nat @ N @ I ) )
        = I ) ) )).

% diff_diff_cancel
thf(fact_7_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_8_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_9_add__diff__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_left
thf(fact_10_add__right__cancel,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
      = ( B = C ) ) )).

% add_right_cancel
thf(fact_11_add__left__cancel,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
      = ( B = C ) ) )).

% add_left_cancel
thf(fact_12_add__le__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_right
thf(fact_13_add__le__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_cancel_left
thf(fact_14_add__less__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_right
thf(fact_15_add__less__cancel__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
      = ( ord_less_nat @ A @ B ) ) )).

% add_less_cancel_left
thf(fact_16_add__diff__cancel__right_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ B )
      = A ) )).

% add_diff_cancel_right'
thf(fact_17_add__diff__cancel__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
      = ( minus_minus_nat @ A @ B ) ) )).

% add_diff_cancel_right
thf(fact_18_add__diff__cancel__left_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ A @ B ) @ A )
      = B ) )).

% add_diff_cancel_left'
thf(fact_19_add__right__imp__eq,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ( plus_plus_nat @ B @ A )
        = ( plus_plus_nat @ C @ A ) )
     => ( B = C ) ) )).

% add_right_imp_eq
thf(fact_20_add__left__imp__eq,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ( plus_plus_nat @ A @ B )
        = ( plus_plus_nat @ A @ C ) )
     => ( B = C ) ) )).

% add_left_imp_eq
thf(fact_21_add_Oleft__commute,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( plus_plus_nat @ B @ ( plus_plus_nat @ A @ C ) )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.left_commute
thf(fact_22_add_Ocommute,axiom,
    ( plus_plus_nat
    = ( ^ [A2: nat,B2: nat] :
          ( plus_plus_nat @ B2 @ A2 ) ) )).

% add.commute
thf(fact_23_add_Oassoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% add.assoc
thf(fact_24_group__cancel_Oadd2,axiom,(
    ! [B3: nat,K: nat,B: nat,A: nat] :
      ( ( B3
        = ( plus_plus_nat @ K @ B ) )
     => ( ( plus_plus_nat @ A @ B3 )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add2
thf(fact_25_group__cancel_Oadd1,axiom,(
    ! [A3: nat,K: nat,A: nat,B: nat] :
      ( ( A3
        = ( plus_plus_nat @ K @ A ) )
     => ( ( plus_plus_nat @ A3 @ B )
        = ( plus_plus_nat @ K @ ( plus_plus_nat @ A @ B ) ) ) ) )).

% group_cancel.add1
thf(fact_26_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( K = L ) )
     => ( ( plus_plus_nat @ I @ K )
        = ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_27_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( plus_plus_nat @ ( plus_plus_nat @ A @ B ) @ C )
      = ( plus_plus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_28_diff__right__commute,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ C ) @ B )
      = ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C ) ) )).

% diff_right_commute
thf(fact_29_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_30_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_31_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_32_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_33_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_34_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_35_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl
thf(fact_36_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less_nat @ M @ N )
        | ( ord_less_nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_37_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_38_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_39_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_40_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_41_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_42_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_43_size__neq__size__imp__neq,axiom,(
    ! [X: list_nat,Y: list_nat] :
      ( ( ( size_size_list_nat @ X )
       != ( size_size_list_nat @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_44_size__neq__size__imp__neq,axiom,(
    ! [X: list_a,Y: list_a] :
      ( ( ( size_size_list_a @ X )
       != ( size_size_list_a @ Y ) )
     => ( X != Y ) ) )).

% size_neq_size_imp_neq
thf(fact_45_eq__imp__diff__eq,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( M = N )
     => ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) ) ) )).

% eq_imp_diff_eq
thf(fact_46_diff__commute,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ I @ J ) @ K )
      = ( minus_minus_nat @ ( minus_minus_nat @ I @ K ) @ J ) ) )).

% diff_commute
thf(fact_47_le__greater__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% le_greater_neq_conv
thf(fact_48_greater__le__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% greater_le_neq_conv
thf(fact_49_less__ge__neq__conv,axiom,
    ( ord_less_nat
    = ( ^ [N3: nat,A2: nat] :
        ! [X3: nat] :
          ( ( ord_less_eq_nat @ A2 @ X3 )
         => ( N3 != X3 ) ) ) )).

% less_ge_neq_conv
thf(fact_50_ge__less__neq__conv,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,N3: nat] :
        ! [X3: nat] :
          ( ( ord_less_nat @ X3 @ A2 )
         => ( N3 != X3 ) ) ) )).

% ge_less_neq_conv
thf(fact_51_add__le__imp__le__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_right
thf(fact_52_add__le__imp__le__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_eq_nat @ A @ B ) ) )).

% add_le_imp_le_left
thf(fact_53_le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
        ? [C2: nat] :
          ( B2
          = ( plus_plus_nat @ A2 @ C2 ) ) ) )).

% le_iff_add
thf(fact_54_add__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_right_mono
thf(fact_55_less__eqE,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ~ ! [C3: nat] :
            ( B
           != ( plus_plus_nat @ A @ C3 ) ) ) )).

% less_eqE
thf(fact_56_add__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_left_mono
thf(fact_57_add__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_mono
thf(fact_58_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_59_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_60_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_61_add__less__imp__less__right,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_right
thf(fact_62_add__less__imp__less__left,axiom,(
    ! [C: nat,A: nat,B: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) )
     => ( ord_less_nat @ A @ B ) ) )).

% add_less_imp_less_left
thf(fact_63_add__strict__right__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ C ) ) ) )).

% add_strict_right_mono
thf(fact_64_add__strict__left__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ord_less_nat @ ( plus_plus_nat @ C @ A ) @ ( plus_plus_nat @ C @ B ) ) ) )).

% add_strict_left_mono
thf(fact_65_add__strict__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_strict_mono
thf(fact_66_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( K = L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_67_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( I = J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_68_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_69_add__implies__diff,axiom,(
    ! [C: nat,B: nat,A: nat] :
      ( ( ( plus_plus_nat @ C @ B )
        = A )
     => ( C
        = ( minus_minus_nat @ A @ B ) ) ) )).

% add_implies_diff
thf(fact_70_diff__diff__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( minus_minus_nat @ ( minus_minus_nat @ A @ B ) @ C )
      = ( minus_minus_nat @ A @ ( plus_plus_nat @ B @ C ) ) ) )).

% diff_diff_add
thf(fact_71_less__mono__imp__le__mono,axiom,(
    ! [F: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_nat @ I2 @ J2 )
         => ( ord_less_nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq_nat @ I @ J )
       => ( ord_less_eq_nat @ ( F @ I ) @ ( F @ J ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_72_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( M != N )
       => ( ord_less_nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_73_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less_nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_74_le__eq__less__or__eq,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) )).

% le_eq_less_or_eq
thf(fact_75_less__imp__le__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% less_imp_le_nat
thf(fact_76_nat__less__le,axiom,
    ( ord_less_nat
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq_nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) )).

% nat_less_le
thf(fact_77_add__less__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ K @ I ) @ ( plus_plus_nat @ K @ J ) ) ) )).

% add_less_mono2
thf(fact_78_less__add__eq__less,axiom,(
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ K @ L )
     => ( ( ( plus_plus_nat @ M @ L )
          = ( plus_plus_nat @ K @ N ) )
       => ( ord_less_nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_79_add__lessD2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ J @ K ) ) )).

% add_lessD2
thf(fact_80_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_81_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_82_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_83_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_84_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_85_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_nat @ I @ J )
     => ( ( ord_less_nat @ K @ L )
       => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_less_mono
thf(fact_86_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ ( plus_plus_nat @ I @ J ) @ K )
     => ( ord_less_nat @ I @ K ) ) )).

% add_lessD1
thf(fact_87_nat__diff__right__cancel__less,axiom,(
    ! [N: nat,K: nat,M: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ N @ K ) @ ( minus_minus_nat @ M @ K ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_right_cancel_less
thf(fact_88_nat__diff__right__cancel__eq2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ N )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq2
thf(fact_89_nat__diff__right__cancel__eq1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( minus_minus_nat @ M @ K )
        = ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( M = N ) ) ) )).

% nat_diff_right_cancel_eq1
thf(fact_90_nat__diff__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ord_less_nat @ N @ M ) ) )).

% nat_diff_left_cancel_less
thf(fact_91_nat__diff__left__cancel__eq2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ N @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq2
thf(fact_92_nat__diff__left__cancel__eq1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( minus_minus_nat @ K @ M )
        = ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( M = N ) ) ) )).

% nat_diff_left_cancel_eq1
thf(fact_93_less__diff__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_nat @ I @ J ) ) )).

% less_diff_imp_less
thf(fact_94_less__imp__diff__less,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_nat @ J @ K )
     => ( ord_less_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% less_imp_diff_less
thf(fact_95_diff__less__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ( ord_less_nat @ M @ L )
       => ( ord_less_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) ) )).

% diff_less_mono2
thf(fact_96_add__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ K @ I ) @ ( plus_plus_nat @ K @ J ) ) ) )).

% add_le_mono2
thf(fact_97_nat__le__iff__add,axiom,
    ( ord_less_eq_nat
    = ( ^ [M3: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus_nat @ M3 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_98_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_99_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ I @ ( plus_plus_nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_100_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_101_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ K @ L )
       => ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_102_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq_nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus_nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_103_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ K @ N ) ) )).

% add_leD2
thf(fact_104_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% add_leD1
thf(fact_105_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ M @ N ) ) )).

% le_add2
thf(fact_106_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq_nat @ N @ ( plus_plus_nat @ N @ M ) ) )).

% le_add1
thf(fact_107_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq_nat @ M @ N )
         => ~ ( ord_less_eq_nat @ K @ N ) ) ) )).

% add_leE
thf(fact_108_nat__diff__right__cancel__le2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le2
thf(fact_109_nat__diff__left__cancel__le2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le2
thf(fact_110_le__diff__le__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% le_diff_le_imp_le
thf(fact_111_eq__diff__left__iff,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ K )
     => ( ( ord_less_eq_nat @ N @ K )
       => ( ( ( minus_minus_nat @ K @ M )
            = ( minus_minus_nat @ K @ N ) )
          = ( M = N ) ) ) ) )).

% eq_diff_left_iff
thf(fact_112_le__imp__diff__le,axiom,(
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ J @ K )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ J @ N ) @ K ) ) )).

% le_imp_diff_le
thf(fact_113_le__diff__imp__le,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ord_less_eq_nat @ I @ J ) ) )).

% le_diff_imp_le
thf(fact_114_le__diff__swap,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ K )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ J ) @ I )
          = ( ord_less_eq_nat @ ( minus_minus_nat @ K @ I ) @ J ) ) ) ) )).

% le_diff_swap
thf(fact_115_diff__le__mono2,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ L @ N ) @ ( minus_minus_nat @ L @ M ) ) ) )).

% diff_le_mono2
thf(fact_116_le__diff__iff_H,axiom,(
    ! [A: nat,C: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ C )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ C @ A ) @ ( minus_minus_nat @ C @ B ) )
          = ( ord_less_eq_nat @ B @ A ) ) ) ) )).

% le_diff_iff'
thf(fact_117_diff__le__self,axiom,(
    ! [M: nat,N: nat] :
      ( ord_less_eq_nat @ ( minus_minus_nat @ M @ N ) @ M ) )).

% diff_le_self
thf(fact_118_diff__le__mono,axiom,(
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ M @ L ) @ ( minus_minus_nat @ N @ L ) ) ) )).

% diff_le_mono
thf(fact_119_Nat_Odiff__diff__eq,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( minus_minus_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( minus_minus_nat @ M @ N ) ) ) ) )).

% Nat.diff_diff_eq
thf(fact_120_le__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_eq_nat @ M @ N ) ) ) ) )).

% le_diff_iff
thf(fact_121_eq__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ( minus_minus_nat @ M @ K )
            = ( minus_minus_nat @ N @ K ) )
          = ( M = N ) ) ) ) )).

% eq_diff_iff
thf(fact_122_diff__add__inverse2,axiom,(
    ! [M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ N ) @ N )
      = M ) )).

% diff_add_inverse2
thf(fact_123_diff__add__inverse,axiom,(
    ! [N: nat,M: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ N )
      = M ) )).

% diff_add_inverse
thf(fact_124_diff__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ ( plus_plus_nat @ N @ K ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% diff_cancel2
thf(fact_125_Nat_Odiff__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus_nat @ ( plus_plus_nat @ K @ M ) @ ( plus_plus_nat @ K @ N ) )
      = ( minus_minus_nat @ M @ N ) ) )).

% Nat.diff_cancel
thf(fact_126_add__less__le__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_less_le_mono
thf(fact_127_add__le__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat,D: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_nat @ C @ D )
       => ( ord_less_nat @ ( plus_plus_nat @ A @ C ) @ ( plus_plus_nat @ B @ D ) ) ) ) )).

% add_le_less_mono
thf(fact_128_add__mono__thms__linordered__field_I3_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_nat @ I @ J )
        & ( ord_less_eq_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(3)
thf(fact_129_add__mono__thms__linordered__field_I4_J,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ( ord_less_eq_nat @ I @ J )
        & ( ord_less_nat @ K @ L ) )
     => ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ ( plus_plus_nat @ J @ L ) ) ) )).

% add_mono_thms_linordered_field(4)
thf(fact_130_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( ( ( minus_minus_nat @ B @ A )
            = C )
          = ( B
            = ( plus_plus_nat @ C @ A ) ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_131_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ A @ ( minus_minus_nat @ B @ A ) )
        = B ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_132_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_133_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A )
        = ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_134_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ C )
        = ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_135_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A )
        = ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_136_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( minus_minus_nat @ ( plus_plus_nat @ C @ B ) @ A ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_137_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ ( minus_minus_nat @ B @ A ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ C @ A ) @ B ) ) ) )).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_138_le__add__diff,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ord_less_eq_nat @ C @ ( minus_minus_nat @ ( plus_plus_nat @ B @ C ) @ A ) ) ) )).

% le_add_diff
thf(fact_139_add__le__add__imp__diff__le,axiom,(
    ! [I: nat,K: nat,N: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
       => ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
         => ( ( ord_less_eq_nat @ N @ ( plus_plus_nat @ J @ K ) )
           => ( ord_less_eq_nat @ ( minus_minus_nat @ N @ K ) @ J ) ) ) ) ) )).

% add_le_add_imp_diff_le
thf(fact_140_diff__add,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( plus_plus_nat @ ( minus_minus_nat @ B @ A ) @ A )
        = B ) ) )).

% diff_add
thf(fact_141_add__le__imp__le__diff,axiom,(
    ! [I: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ N )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ N @ K ) ) ) )).

% add_le_imp_le_diff
thf(fact_142_linordered__semidom__class_Oadd__diff__inverse,axiom,(
    ! [A: nat,B: nat] :
      ( ~ ( ord_less_nat @ A @ B )
     => ( ( plus_plus_nat @ B @ ( minus_minus_nat @ A @ B ) )
        = A ) ) )).

% linordered_semidom_class.add_diff_inverse
thf(fact_143_mono__nat__linear__lb,axiom,(
    ! [F: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N2: nat] :
          ( ( ord_less_nat @ M4 @ N2 )
         => ( ord_less_nat @ ( F @ M4 ) @ ( F @ N2 ) ) )
     => ( ord_less_eq_nat @ ( plus_plus_nat @ ( F @ M ) @ K ) @ ( F @ ( plus_plus_nat @ M @ K ) ) ) ) )).

% mono_nat_linear_lb
thf(fact_144_nat__diff__right__cancel__le1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
     => ( ( ord_less_nat @ K @ M )
       => ( ord_less_eq_nat @ M @ N ) ) ) )).

% nat_diff_right_cancel_le1
thf(fact_145_nat__diff__left__cancel__le1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ K @ M ) @ ( minus_minus_nat @ K @ N ) )
     => ( ( ord_less_nat @ M @ K )
       => ( ord_less_eq_nat @ N @ M ) ) ) )).

% nat_diff_left_cancel_le1
thf(fact_146_less__diff__le__imp__less,axiom,(
    ! [I: nat,J: nat,M: nat,N: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ M ) )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( ord_less_nat @ I @ ( minus_minus_nat @ J @ N ) ) ) ) )).

% less_diff_le_imp_less
thf(fact_147_diff__less__mono,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_eq_nat @ C @ A )
       => ( ord_less_nat @ ( minus_minus_nat @ A @ C ) @ ( minus_minus_nat @ B @ C ) ) ) ) )).

% diff_less_mono
thf(fact_148_less__diff__iff,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq_nat @ K @ M )
     => ( ( ord_less_eq_nat @ K @ N )
       => ( ( ord_less_nat @ ( minus_minus_nat @ M @ K ) @ ( minus_minus_nat @ N @ K ) )
          = ( ord_less_nat @ M @ N ) ) ) ) )).

% less_diff_iff
thf(fact_149_diff__less__imp__less__add,axiom,(
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_nat @ ( minus_minus_nat @ J @ K ) @ I )
     => ( ord_less_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) )).

% diff_less_imp_less_add
thf(fact_150_add__diff__inverse__nat,axiom,(
    ! [M: nat,N: nat] :
      ( ~ ( ord_less_nat @ M @ N )
     => ( ( plus_plus_nat @ N @ ( minus_minus_nat @ M @ N ) )
        = M ) ) )).

% add_diff_inverse_nat
thf(fact_151_less__add__diff,axiom,(
    ! [K: nat,N: nat,M: nat] :
      ( ( ord_less_nat @ K @ N )
     => ( ord_less_nat @ M @ ( minus_minus_nat @ ( plus_plus_nat @ N @ M ) @ K ) ) ) )).

% less_add_diff
thf(fact_152_less__diff__conv,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_nat @ I @ ( minus_minus_nat @ J @ K ) )
      = ( ord_less_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) )).

% less_diff_conv
thf(fact_153_add__le__imp__le__diff2,axiom,(
    ! [K: nat,I: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ K @ I ) @ J )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) )).

% add_le_imp_le_diff2
thf(fact_154_add__le__imp__le__diff1,axiom,(
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J )
     => ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) )).

% add_le_imp_le_diff1
thf(fact_155_Nat_Ole__imp__diff__is__add,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ( minus_minus_nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus_nat @ K @ I ) ) ) ) )).

% Nat.le_imp_diff_is_add
thf(fact_156_add__diff__le,axiom,(
    ! [K: nat,N: nat,M: nat] :
      ( ( ord_less_eq_nat @ K @ N )
     => ( ord_less_eq_nat @ ( minus_minus_nat @ ( plus_plus_nat @ M @ K ) @ N ) @ M ) ) )).

% add_diff_le
thf(fact_157_Nat_Odiff__add__assoc2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ J @ I ) @ K )
        = ( plus_plus_nat @ ( minus_minus_nat @ J @ K ) @ I ) ) ) )).

% Nat.diff_add_assoc2
thf(fact_158_Nat_Odiff__add__assoc,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( minus_minus_nat @ ( plus_plus_nat @ I @ J ) @ K )
        = ( plus_plus_nat @ I @ ( minus_minus_nat @ J @ K ) ) ) ) )).

% Nat.diff_add_assoc
thf(fact_159_Nat_Ole__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_eq_nat @ I @ ( minus_minus_nat @ J @ K ) )
        = ( ord_less_eq_nat @ ( plus_plus_nat @ I @ K ) @ J ) ) ) )).

% Nat.le_diff_conv2
thf(fact_160_le__diff__conv,axiom,(
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq_nat @ ( minus_minus_nat @ J @ K ) @ I )
      = ( ord_less_eq_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) )).

% le_diff_conv
thf(fact_161_less__diff__conv2,axiom,(
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq_nat @ K @ J )
     => ( ( ord_less_nat @ ( minus_minus_nat @ J @ K ) @ I )
        = ( ord_less_nat @ J @ ( plus_plus_nat @ I @ K ) ) ) ) )).

% less_diff_conv2
thf(fact_162_list__eq__iff__nth__eq,axiom,
    ( ( ^ [Y4: list_nat,Z: list_nat] : ( Y4 = Z ) )
    = ( ^ [Xs: list_nat,Ys: list_nat] :
          ( ( ( size_size_list_nat @ Xs )
            = ( size_size_list_nat @ Ys ) )
          & ! [I3: nat] :
              ( ( ord_less_nat @ I3 @ ( size_size_list_nat @ Xs ) )
             => ( ( nth_nat @ Xs @ I3 )
                = ( nth_nat @ Ys @ I3 ) ) ) ) ) )).

% list_eq_iff_nth_eq
thf(fact_163_list__eq__iff__nth__eq,axiom,
    ( ( ^ [Y4: list_a,Z: list_a] : ( Y4 = Z ) )
    = ( ^ [Xs: list_a,Ys: list_a] :
          ( ( ( size_size_list_a @ Xs )
            = ( size_size_list_a @ Ys ) )
          & ! [I3: nat] :
              ( ( ord_less_nat @ I3 @ ( size_size_list_a @ Xs ) )
             => ( ( nth_a @ Xs @ I3 )
                = ( nth_a @ Ys @ I3 ) ) ) ) ) )).

% list_eq_iff_nth_eq
thf(fact_164_Skolem__list__nth,axiom,(
    ! [K: nat,P: nat > nat > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ K )
           => ? [X4: nat] :
                ( P @ I3 @ X4 ) ) )
      = ( ? [Xs: list_nat] :
            ( ( ( size_size_list_nat @ Xs )
              = K )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K )
               => ( P @ I3 @ ( nth_nat @ Xs @ I3 ) ) ) ) ) ) )).

% Skolem_list_nth
thf(fact_165_Skolem__list__nth,axiom,(
    ! [K: nat,P: nat > a > $o] :
      ( ( ! [I3: nat] :
            ( ( ord_less_nat @ I3 @ K )
           => ? [X4: a] :
                ( P @ I3 @ X4 ) ) )
      = ( ? [Xs: list_a] :
            ( ( ( size_size_list_a @ Xs )
              = K )
            & ! [I3: nat] :
                ( ( ord_less_nat @ I3 @ K )
               => ( P @ I3 @ ( nth_a @ Xs @ I3 ) ) ) ) ) ) )).

% Skolem_list_nth
thf(fact_166_nth__equalityI,axiom,(
    ! [Xs2: list_nat,Ys2: list_nat] :
      ( ( ( size_size_list_nat @ Xs2 )
        = ( size_size_list_nat @ Ys2 ) )
     => ( ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( size_size_list_nat @ Xs2 ) )
           => ( ( nth_nat @ Xs2 @ I2 )
              = ( nth_nat @ Ys2 @ I2 ) ) )
       => ( Xs2 = Ys2 ) ) ) )).

% nth_equalityI
thf(fact_167_nth__equalityI,axiom,(
    ! [Xs2: list_a,Ys2: list_a] :
      ( ( ( size_size_list_a @ Xs2 )
        = ( size_size_list_a @ Ys2 ) )
     => ( ! [I2: nat] :
            ( ( ord_less_nat @ I2 @ ( size_size_list_a @ Xs2 ) )
           => ( ( nth_a @ Xs2 @ I2 )
              = ( nth_a @ Ys2 @ I2 ) ) )
       => ( Xs2 = Ys2 ) ) ) )).

% nth_equalityI
thf(fact_168_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_169_list__desc__trans__le,axiom,
    ( list_desc_nat
    = ( ^ [Xs: list_nat] :
        ! [J3: nat] :
          ( ( ord_less_nat @ J3 @ ( size_size_list_nat @ Xs ) )
         => ! [I3: nat] :
              ( ( ord_less_eq_nat @ I3 @ J3 )
             => ( ord_less_eq_nat @ ( nth_nat @ Xs @ J3 ) @ ( nth_nat @ Xs @ I3 ) ) ) ) ) )).

% list_desc_trans_le
thf(fact_170_length__induct,axiom,(
    ! [P: list_nat > $o,Xs2: list_nat] :
      ( ! [Xs3: list_nat] :
          ( ! [Ys3: list_nat] :
              ( ( ord_less_nat @ ( size_size_list_nat @ Ys3 ) @ ( size_size_list_nat @ Xs3 ) )
             => ( P @ Ys3 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs2 ) ) )).

% length_induct
thf(fact_171_length__induct,axiom,(
    ! [P: list_a > $o,Xs2: list_a] :
      ( ! [Xs3: list_a] :
          ( ! [Ys3: list_a] :
              ( ( ord_less_nat @ ( size_size_list_a @ Ys3 ) @ ( size_size_list_a @ Xs3 ) )
             => ( P @ Ys3 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs2 ) ) )).

% length_induct
thf(fact_172_nat__descend__induct,axiom,(
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K3: nat] :
          ( ( ord_less_nat @ N @ K3 )
         => ( P @ K3 ) )
     => ( ! [K3: nat] :
            ( ( ord_less_eq_nat @ K3 @ N )
           => ( ! [I4: nat] :
                  ( ( ord_less_nat @ K3 @ I4 )
                 => ( P @ I4 ) )
             => ( P @ K3 ) ) )
       => ( P @ M ) ) ) )).

% nat_descend_induct
thf(fact_173_list__strict__asc__trans__le,axiom,(
    ! [Xs2: list_nat] :
      ( ( list_strict_asc_nat @ Xs2 )
     => ! [J4: nat] :
          ( ( ord_less_nat @ J4 @ ( size_size_list_nat @ Xs2 ) )
         => ! [I4: nat] :
              ( ( ord_less_eq_nat @ I4 @ J4 )
             => ( ord_less_eq_nat @ ( nth_nat @ Xs2 @ I4 ) @ ( nth_nat @ Xs2 @ J4 ) ) ) ) ) )).

% list_strict_asc_trans_le
thf(fact_174_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_175_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_176_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_177_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_178_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [X3: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X3 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X3 ) ) ) )).

% eq_iff
thf(fact_179_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_180_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_181_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_182_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_183_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_184_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z2 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z2 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z2 )
           => ~ ( ord_less_eq_nat @ Z2 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z2 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z2 )
               => ~ ( ord_less_eq_nat @ Z2 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z2 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_185_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_186_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_187_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_188_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_189_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_190_order__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z2 )
       => ( ord_less_eq_nat @ X @ Z2 ) ) ) )).

% order_trans
thf(fact_191_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_192_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: nat,B4: nat] :
            ( ( P @ B4 @ A4 )
           => ( P @ A4 @ B4 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_193_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_194_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z: nat] : ( Y4 = Z ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_195_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_196_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_197_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_198_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_199_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_200_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_1: nat] :
      ( ord_less_nat @ X @ X_1 ) )).

% gt_ex
thf(fact_201_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_202_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_203_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_204_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_205_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_206_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_207_less__trans,axiom,(
    ! [X: nat,Y: nat,Z2: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z2 )
       => ( ord_less_nat @ X @ Z2 ) ) ) )).

% less_trans
thf(fact_208_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_209_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_210_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_211_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_212_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_213_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_214_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_215_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P @ Y3 ) )
         => ( P @ X2 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_216_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_217_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_218_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_219_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_220_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_221_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_222_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less

% Conjectures (3)
thf(conj_0,hypothesis,(
    ord_less_eq_nat @ ( size_size_list_a @ xs ) @ ( size_size_list_a @ ys ) )).

thf(conj_1,hypothesis,(
    ! [X5: nat] :
      ( ( ( ord_less_nat @ X5 @ ( size_size_list_a @ xs ) )
       => ( ( nth_a @ xs @ X5 )
          = ( nth_a @ ys @ X5 ) ) )
      & ( ~ ( ord_less_nat @ X5 @ ( size_size_list_a @ xs ) )
       => ( ( ( ord_less_nat @ X5 @ ( size_size_list_a @ ys ) )
           => ( ( f @ ( minus_minus_nat @ X5 @ ( size_size_list_a @ xs ) ) )
              = ( nth_a @ ys @ X5 ) ) )
          & ( ~ ( ord_less_nat @ X5 @ ( size_size_list_a @ ys ) )
           => ( ( f @ ( minus_minus_nat @ X5 @ ( size_size_list_a @ xs ) ) )
              = ( g @ ( minus_minus_nat @ X5 @ ( size_size_list_a @ ys ) ) ) ) ) ) ) ) )).

thf(conj_2,conjecture,(
    ! [X2: nat] :
      ( ( ~ ( ord_less_nat @ X2 @ ( minus_minus_nat @ ( size_size_list_a @ ys ) @ ( size_size_list_a @ xs ) ) )
        | ( ( f @ X2 )
          = ( nth_a @ ys @ ( plus_plus_nat @ ( size_size_list_a @ xs ) @ X2 ) ) ) )
      & ( ( ord_less_nat @ X2 @ ( minus_minus_nat @ ( size_size_list_a @ ys ) @ ( size_size_list_a @ xs ) ) )
        | ( ( f @ X2 )
          = ( g @ ( minus_minus_nat @ ( plus_plus_nat @ X2 @ ( size_size_list_a @ xs ) ) @ ( size_size_list_a @ ys ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
