%------------------------------------------------------------------------------
% File     : SLP070^1 : TPTP v7.5.0. Released v7.5.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer NthRoot_Impl problem prob_289__3276180_1
% Version  : Especial.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Der21] Desharnais (2021), Email to Geoff Sutcliffe
% Source   : [Der21]
% Names    : NthRoot_Impl/prob_289__3276180_1 [Der21]

% Status   : Theorem
% Rating   : ? v7.5.0
% Syntax   : Number of formulae    :  381 (   0 unit;  28 type;   0 defn)
%            Number of atoms       : 3636 ( 351 equality;2108 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 2705 ( 124   ~;  29   |;  31   &;2060   @)
%                                         (   0 <=>; 461  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  126 ( 126   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   32 (  28   :;   0   =)
%            Number of variables   :  987 (   0 sgn; 908   !;  45   ?;  34   ^)
%                                         ( 987   :;   0  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH0_THM_EQU_NAR

% Comments : This file was generated by Sledgehammer 2021-02-23 15:41:21.585
%------------------------------------------------------------------------------
% Could-be-implicit typings (4)
thf(ty_n_t__Product____Type__Oprod_It__Int__Oint_Mt__Int__Oint_J,type,(
    product_prod_int_int: $tType )).

thf(ty_n_t__Product____Type__Oprod_It__Int__Oint_M_Eo_J,type,(
    product_prod_int_o: $tType )).

thf(ty_n_t__Nat__Onat,type,(
    nat: $tType )).

thf(ty_n_t__Int__Oint,type,(
    int: $tType )).

% Explicit typings (24)
thf(sy_c_Groups_Ozero__class_Ozero_001t__Int__Oint,type,(
    zero_zero_int: int )).

thf(sy_c_Groups_Ozero__class_Ozero_001t__Nat__Onat,type,(
    zero_zero_nat: nat )).

thf(sy_c_If_001t__Nat__Onat,type,(
    if_nat: $o > nat > nat > nat )).

thf(sy_c_Int_Oring__1__class_Oof__int_001t__Int__Oint,type,(
    ring_1_of_int_int: int > int )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat_001t__Int__Oint,type,(
    semiri2019852685at_int: nat > int )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat_001t__Nat__Onat,type,(
    semiri1382578993at_nat: nat > nat )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ofixed__root,type,(
    nthRoo1352626670d_root: nat > nat > $o )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Ofixed__root_Oroot__newton__int__main,type,(
    nthRoo745073429t_main: nat > nat > int > int > product_prod_int_o )).

thf(sy_c_NthRoot__Impl__Mirabelle__bcfbdygymo_Oroot__int__main_H,type,(
    nthRoo2086695111t_main: nat > int > int > int > int > product_prod_int_o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Int__Oint,type,(
    ord_less_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless_001t__Nat__Onat,type,(
    ord_less_nat: nat > nat > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Int__Oint,type,(
    ord_less_eq_int: int > int > $o )).

thf(sy_c_Orderings_Oord__class_Oless__eq_001t__Nat__Onat,type,(
    ord_less_eq_nat: nat > nat > $o )).

thf(sy_c_Power_Opower__class_Opower_001t__Int__Oint,type,(
    power_power_int: int > nat > int )).

thf(sy_c_Power_Opower__class_Opower_001t__Nat__Onat,type,(
    power_power_nat: nat > nat > nat )).

thf(sy_c_Product__Type_OPair_001t__Int__Oint_001_Eo,type,(
    product_Pair_int_o: int > $o > product_prod_int_o )).

thf(sy_c_Product__Type_OPair_001t__Int__Oint_001t__Int__Oint,type,(
    product_Pair_int_int: int > int > product_prod_int_int )).

thf(sy_v_b,type,(
    b: $o )).

thf(sy_v_n,type,(
    n: int )).

thf(sy_v_p,type,(
    p: nat )).

thf(sy_v_pm,type,(
    pm: nat )).

thf(sy_v_x,type,(
    x: int )).

thf(sy_v_y,type,(
    y: int )).

% Relevant facts (346)
thf(fact_0_root__main_H__newton__pos,axiom,(
    ! [X: int,N: int,Y: int,B: $o] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_eq_int @ zero_zero_int @ N )
       => ( ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ X @ N )
            = ( nthRoo745073429t_main @ p @ pm @ X @ N ) )
          & ( ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ X @ N )
              = ( product_Pair_int_o @ Y @ B ) )
           => ( ( ord_less_eq_int @ zero_zero_int @ Y )
              & ( ord_less_eq_int @ ( power_power_int @ Y @ p ) @ N )
              & ( B
                = ( ( power_power_int @ Y @ p )
                  = N ) ) ) ) ) ) ) )).

% root_main'_newton_pos
thf(fact_1_fixed__root__axioms,axiom,(
    nthRoo1352626670d_root @ p @ pm )).

% fixed_root_axioms
thf(fact_2_root__main_H__pos,axiom,(
    ! [X: int,N: int,Y: int,B: $o] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_eq_int @ zero_zero_int @ N )
       => ( ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ X @ N )
            = ( product_Pair_int_o @ Y @ B ) )
         => ( ord_less_eq_int @ zero_zero_int @ Y ) ) ) ) )).

% root_main'_pos
thf(fact_3_root__main_H__sound,axiom,(
    ! [X: int,N: int,Y: int,B: $o] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_eq_int @ zero_zero_int @ N )
       => ( ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ X @ N )
            = ( product_Pair_int_o @ Y @ B ) )
         => ( B
            = ( ( power_power_int @ Y @ p )
              = N ) ) ) ) ) )).

% root_main'_sound
thf(fact_4_root__main_H,axiom,(
    ! [X: int,N: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ X )
     => ( ( ord_less_eq_int @ zero_zero_int @ N )
       => ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ X @ N )
          = ( nthRoo745073429t_main @ p @ pm @ X @ N ) ) ) ) )).

% root_main'
thf(fact_5_of__nat__le__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ord_less_eq_int @ ( power_power_int @ ( semiri2019852685at_int @ B ) @ W ) @ ( semiri2019852685at_int @ X ) )
      = ( ord_less_eq_nat @ ( power_power_nat @ B @ W ) @ X ) ) )).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_6_of__nat__le__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ord_less_eq_nat @ ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W ) @ ( semiri1382578993at_nat @ X ) )
      = ( ord_less_eq_nat @ ( power_power_nat @ B @ W ) @ X ) ) )).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_7_of__nat__power__le__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ord_less_eq_int @ ( semiri2019852685at_int @ X ) @ ( power_power_int @ ( semiri2019852685at_int @ B ) @ W ) )
      = ( ord_less_eq_nat @ X @ ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_8_of__nat__power__le__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ord_less_eq_nat @ ( semiri1382578993at_nat @ X ) @ ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W ) )
      = ( ord_less_eq_nat @ X @ ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_9_of__nat__le__0__iff,axiom,(
    ! [M: nat] :
      ( ( ord_less_eq_int @ ( semiri2019852685at_int @ M ) @ zero_zero_int )
      = ( M = zero_zero_nat ) ) )).

% of_nat_le_0_iff
thf(fact_10_of__nat__le__0__iff,axiom,(
    ! [M: nat] :
      ( ( ord_less_eq_nat @ ( semiri1382578993at_nat @ M ) @ zero_zero_nat )
      = ( M = zero_zero_nat ) ) )).

% of_nat_le_0_iff
thf(fact_11_of__nat__power,axiom,(
    ! [M: nat,N: nat] :
      ( ( semiri1382578993at_nat @ ( power_power_nat @ M @ N ) )
      = ( power_power_nat @ ( semiri1382578993at_nat @ M ) @ N ) ) )).

% of_nat_power
thf(fact_12_of__nat__power,axiom,(
    ! [M: nat,N: nat] :
      ( ( semiri2019852685at_int @ ( power_power_nat @ M @ N ) )
      = ( power_power_int @ ( semiri2019852685at_int @ M ) @ N ) ) )).

% of_nat_power
thf(fact_13_of__nat__eq__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W )
        = ( semiri1382578993at_nat @ X ) )
      = ( ( power_power_nat @ B @ W )
        = X ) ) )).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_14_of__nat__eq__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ( power_power_int @ ( semiri2019852685at_int @ B ) @ W )
        = ( semiri2019852685at_int @ X ) )
      = ( ( power_power_nat @ B @ W )
        = X ) ) )).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_15_of__nat__power__eq__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ( semiri2019852685at_int @ X )
        = ( power_power_int @ ( semiri2019852685at_int @ B ) @ W ) )
      = ( X
        = ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_16_of__nat__power__eq__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ( semiri1382578993at_nat @ X )
        = ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W ) )
      = ( X
        = ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_17_of__nat__0,axiom,
    ( ( semiri2019852685at_int @ zero_zero_nat )
    = zero_zero_int )).

% of_nat_0
thf(fact_18_of__nat__0,axiom,
    ( ( semiri1382578993at_nat @ zero_zero_nat )
    = zero_zero_nat )).

% of_nat_0
thf(fact_19_of__nat__0__eq__iff,axiom,(
    ! [N: nat] :
      ( ( zero_zero_int
        = ( semiri2019852685at_int @ N ) )
      = ( zero_zero_nat = N ) ) )).

% of_nat_0_eq_iff
thf(fact_20_of__nat__0__eq__iff,axiom,(
    ! [N: nat] :
      ( ( zero_zero_nat
        = ( semiri1382578993at_nat @ N ) )
      = ( zero_zero_nat = N ) ) )).

% of_nat_0_eq_iff
thf(fact_21_of__nat__eq__0__iff,axiom,(
    ! [M: nat] :
      ( ( ( semiri2019852685at_int @ M )
        = zero_zero_int )
      = ( M = zero_zero_nat ) ) )).

% of_nat_eq_0_iff
thf(fact_22_of__nat__eq__0__iff,axiom,(
    ! [M: nat] :
      ( ( ( semiri1382578993at_nat @ M )
        = zero_zero_nat )
      = ( M = zero_zero_nat ) ) )).

% of_nat_eq_0_iff
thf(fact_23_of__nat__le__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_int @ ( semiri2019852685at_int @ M ) @ ( semiri2019852685at_int @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% of_nat_le_iff
thf(fact_24_of__nat__le__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( semiri1382578993at_nat @ M ) @ ( semiri1382578993at_nat @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% of_nat_le_iff
thf(fact_25_le__zero__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_zero_eq
thf(fact_26_nonneg__int__cases,axiom,(
    ! [K: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ K )
     => ~ ! [N2: nat] :
            ( K
           != ( semiri2019852685at_int @ N2 ) ) ) )).

% nonneg_int_cases
thf(fact_27_p0,axiom,(
    p != zero_zero_nat )).

% p0
thf(fact_28_of__nat__eq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( semiri2019852685at_int @ M )
        = ( semiri2019852685at_int @ N ) )
      = ( M = N ) ) )).

% of_nat_eq_iff
thf(fact_29_of__nat__eq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( semiri1382578993at_nat @ M )
        = ( semiri1382578993at_nat @ N ) )
      = ( M = N ) ) )).

% of_nat_eq_iff
thf(fact_30_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% le0
thf(fact_31_bot__nat__0_Oextremum,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ A ) )).

% bot_nat_0.extremum
thf(fact_32_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ N ) )).

% less_eq_nat.simps(1)
thf(fact_33_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq_nat @ N @ zero_zero_nat )
      = ( N = zero_zero_nat ) ) )).

% le_0_eq
thf(fact_34_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ N @ N ) )).

% le_refl
thf(fact_35_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ( ord_less_eq_nat @ J @ K )
       => ( ord_less_eq_nat @ I @ K ) ) ) )).

% le_trans
thf(fact_36_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_37_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( ord_less_eq_nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_38_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
      | ( ord_less_eq_nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_39_Nat_Oex__has__greatest__nat,axiom,(
    ! [P: nat > $o,K: nat,B: nat] :
      ( ( P @ K )
     => ( ! [Y2: nat] :
            ( ( P @ Y2 )
           => ( ord_less_eq_nat @ Y2 @ B ) )
       => ? [X2: nat] :
            ( ( P @ X2 )
            & ! [Y3: nat] :
                ( ( P @ Y3 )
               => ( ord_less_eq_nat @ Y3 @ X2 ) ) ) ) ) )).

% Nat.ex_has_greatest_nat
thf(fact_40_bot__nat__0_Oextremum__unique,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
      = ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_unique
thf(fact_41_bot__nat__0_Oextremum__uniqueI,axiom,(
    ! [A: nat] :
      ( ( ord_less_eq_nat @ A @ zero_zero_nat )
     => ( A = zero_zero_nat ) ) )).

% bot_nat_0.extremum_uniqueI
thf(fact_42_fixed__root_Op0,axiom,(
    ! [P2: nat,Pm: nat] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( P2 != zero_zero_nat ) ) )).

% fixed_root.p0
thf(fact_43_zle__int,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_int @ ( semiri2019852685at_int @ M ) @ ( semiri2019852685at_int @ N ) )
      = ( ord_less_eq_nat @ M @ N ) ) )).

% zle_int
thf(fact_44_fixed__root_Oroot__newton__int__main_Ocong,axiom,(
    nthRoo745073429t_main = nthRoo745073429t_main )).

% fixed_root.root_newton_int_main.cong
thf(fact_45_zero__reorient,axiom,(
    ! [X: int] :
      ( ( zero_zero_int = X )
      = ( X = zero_zero_int ) ) )).

% zero_reorient
thf(fact_46_zero__reorient,axiom,(
    ! [X: nat] :
      ( ( zero_zero_nat = X )
      = ( X = zero_zero_nat ) ) )).

% zero_reorient
thf(fact_47_int__int__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( semiri2019852685at_int @ M )
        = ( semiri2019852685at_int @ N ) )
      = ( M = N ) ) )).

% int_int_eq
thf(fact_48_fixed__root_Oroot__main_H,axiom,(
    ! [P2: nat,Pm: nat,X: int,N: int] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ N )
         => ( ( nthRoo2086695111t_main @ Pm @ ( semiri2019852685at_int @ Pm ) @ ( semiri2019852685at_int @ P2 ) @ X @ N )
            = ( nthRoo745073429t_main @ P2 @ Pm @ X @ N ) ) ) ) ) )).

% fixed_root.root_main'
thf(fact_49_zero__le,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ X ) )).

% zero_le
thf(fact_50_power__not__zero,axiom,(
    ! [A: int,N: nat] :
      ( ( A != zero_zero_int )
     => ( ( power_power_int @ A @ N )
       != zero_zero_int ) ) )).

% power_not_zero
thf(fact_51_power__not__zero,axiom,(
    ! [A: nat,N: nat] :
      ( ( A != zero_zero_nat )
     => ( ( power_power_nat @ A @ N )
       != zero_zero_nat ) ) )).

% power_not_zero
thf(fact_52_of__nat__mono,axiom,(
    ! [I: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_int @ ( semiri2019852685at_int @ I ) @ ( semiri2019852685at_int @ J ) ) ) )).

% of_nat_mono
thf(fact_53_of__nat__mono,axiom,(
    ! [I: nat,J: nat] :
      ( ( ord_less_eq_nat @ I @ J )
     => ( ord_less_eq_nat @ ( semiri1382578993at_nat @ I ) @ ( semiri1382578993at_nat @ J ) ) ) )).

% of_nat_mono
thf(fact_54_less__eq__int__code_I1_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% less_eq_int_code(1)
thf(fact_55_fixed__root_Oroot__main_H__newton__pos,axiom,(
    ! [P2: nat,Pm: nat,X: int,N: int,Y: int,B: $o] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ N )
         => ( ( ( nthRoo2086695111t_main @ Pm @ ( semiri2019852685at_int @ Pm ) @ ( semiri2019852685at_int @ P2 ) @ X @ N )
              = ( nthRoo745073429t_main @ P2 @ Pm @ X @ N ) )
            & ( ( ( nthRoo2086695111t_main @ Pm @ ( semiri2019852685at_int @ Pm ) @ ( semiri2019852685at_int @ P2 ) @ X @ N )
                = ( product_Pair_int_o @ Y @ B ) )
             => ( ( ord_less_eq_int @ zero_zero_int @ Y )
                & ( ord_less_eq_int @ ( power_power_int @ Y @ P2 ) @ N )
                & ( B
                  = ( ( power_power_int @ Y @ P2 )
                    = N ) ) ) ) ) ) ) ) )).

% fixed_root.root_main'_newton_pos
thf(fact_56_fixed__root_Oroot__main_H__pos,axiom,(
    ! [P2: nat,Pm: nat,X: int,N: int,Y: int,B: $o] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ N )
         => ( ( ( nthRoo2086695111t_main @ Pm @ ( semiri2019852685at_int @ Pm ) @ ( semiri2019852685at_int @ P2 ) @ X @ N )
              = ( product_Pair_int_o @ Y @ B ) )
           => ( ord_less_eq_int @ zero_zero_int @ Y ) ) ) ) ) )).

% fixed_root.root_main'_pos
thf(fact_57_fixed__root_Oroot__main_H__sound,axiom,(
    ! [P2: nat,Pm: nat,X: int,N: int,Y: int,B: $o] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( ( ord_less_eq_int @ zero_zero_int @ X )
       => ( ( ord_less_eq_int @ zero_zero_int @ N )
         => ( ( ( nthRoo2086695111t_main @ Pm @ ( semiri2019852685at_int @ Pm ) @ ( semiri2019852685at_int @ P2 ) @ X @ N )
              = ( product_Pair_int_o @ Y @ B ) )
           => ( B
              = ( ( power_power_int @ Y @ P2 )
                = N ) ) ) ) ) ) )).

% fixed_root.root_main'_sound
thf(fact_58_zero__le__power,axiom,(
    ! [A: int,N: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ A )
     => ( ord_less_eq_int @ zero_zero_int @ ( power_power_int @ A @ N ) ) ) )).

% zero_le_power
thf(fact_59_zero__le__power,axiom,(
    ! [A: nat,N: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ord_less_eq_nat @ zero_zero_nat @ ( power_power_nat @ A @ N ) ) ) )).

% zero_le_power
thf(fact_60_power__mono,axiom,(
    ! [A: int,B: int,N: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ord_less_eq_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) ) ) ) )).

% power_mono
thf(fact_61_power__mono,axiom,(
    ! [A: nat,B: nat,N: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ord_less_eq_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) ) ) ) )).

% power_mono
thf(fact_62_of__nat__0__le__iff,axiom,(
    ! [N: nat] :
      ( ord_less_eq_int @ zero_zero_int @ ( semiri2019852685at_int @ N ) ) )).

% of_nat_0_le_iff
thf(fact_63_of__nat__0__le__iff,axiom,(
    ! [N: nat] :
      ( ord_less_eq_nat @ zero_zero_nat @ ( semiri1382578993at_nat @ N ) ) )).

% of_nat_0_le_iff
thf(fact_64_zero__le__imp__eq__int,axiom,(
    ! [K: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ K )
     => ? [N2: nat] :
          ( K
          = ( semiri2019852685at_int @ N2 ) ) ) )).

% zero_le_imp_eq_int
thf(fact_65_nat__int__comparison_I3_J,axiom,
    ( ord_less_eq_nat
    = ( ^ [A2: nat,B2: nat] :
          ( ord_less_eq_int @ ( semiri2019852685at_int @ A2 ) @ ( semiri2019852685at_int @ B2 ) ) ) )).

% nat_int_comparison(3)
thf(fact_66_int__ops_I1_J,axiom,
    ( ( semiri2019852685at_int @ zero_zero_nat )
    = zero_zero_int )).

% int_ops(1)
thf(fact_67_p,axiom,
    ( p
    = ( suc @ pm ) )).

% p
thf(fact_68_old_Oprod_Oinject,axiom,(
    ! [A: int,B: $o,A3: int,B3: $o] :
      ( ( ( product_Pair_int_o @ A @ B )
        = ( product_Pair_int_o @ A3 @ B3 ) )
      = ( ( A = A3 )
        & ( B = B3 ) ) ) )).

% old.prod.inject
thf(fact_69_old_Oprod_Oinject,axiom,(
    ! [A: int,B: int,A3: int,B3: int] :
      ( ( ( product_Pair_int_int @ A @ B )
        = ( product_Pair_int_int @ A3 @ B3 ) )
      = ( ( A = A3 )
        & ( B = B3 ) ) ) )).

% old.prod.inject
thf(fact_70_prod_Oinject,axiom,(
    ! [X1: int,X22: $o,Y1: int,Y22: $o] :
      ( ( ( product_Pair_int_o @ X1 @ X22 )
        = ( product_Pair_int_o @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_71_prod_Oinject,axiom,(
    ! [X1: int,X22: int,Y1: int,Y22: int] :
      ( ( ( product_Pair_int_int @ X1 @ X22 )
        = ( product_Pair_int_int @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_72_order__refl,axiom,(
    ! [X: int] :
      ( ord_less_eq_int @ X @ X ) )).

% order_refl
thf(fact_73_order__refl,axiom,(
    ! [X: nat] :
      ( ord_less_eq_nat @ X @ X ) )).

% order_refl
thf(fact_74_conj__le__cong,axiom,(
    ! [X: int,X3: int,P: $o,P3: $o] :
      ( ( X = X3 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X3 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
            & P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X3 )
            & P3 ) ) ) ) )).

% conj_le_cong
thf(fact_75_imp__le__cong,axiom,(
    ! [X: int,X3: int,P: $o,P3: $o] :
      ( ( X = X3 )
     => ( ( ( ord_less_eq_int @ zero_zero_int @ X3 )
         => ( P = P3 ) )
       => ( ( ( ord_less_eq_int @ zero_zero_int @ X )
           => P )
          = ( ( ord_less_eq_int @ zero_zero_int @ X3 )
           => P3 ) ) ) ) )).

% imp_le_cong
thf(fact_76_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_int @ zero_zero_int @ zero_zero_int )).

% le_numeral_extra(3)
thf(fact_77_le__numeral__extra_I3_J,axiom,(
    ord_less_eq_nat @ zero_zero_nat @ zero_zero_nat )).

% le_numeral_extra(3)
thf(fact_78_nat_Oinject,axiom,(
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% nat.inject
thf(fact_79_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_80_Suc__le__mono,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq_nat @ N @ M ) ) )).

% Suc_le_mono
thf(fact_81_power__0__Suc,axiom,(
    ! [N: nat] :
      ( ( power_power_int @ zero_zero_int @ ( suc @ N ) )
      = zero_zero_int ) )).

% power_0_Suc
thf(fact_82_power__0__Suc,axiom,(
    ! [N: nat] :
      ( ( power_power_nat @ zero_zero_nat @ ( suc @ N ) )
      = zero_zero_nat ) )).

% power_0_Suc
thf(fact_83_power__Suc0__right,axiom,(
    ! [A: int] :
      ( ( power_power_int @ A @ ( suc @ zero_zero_nat ) )
      = A ) )).

% power_Suc0_right
thf(fact_84_power__Suc0__right,axiom,(
    ! [A: nat] :
      ( ( power_power_nat @ A @ ( suc @ zero_zero_nat ) )
      = A ) )).

% power_Suc0_right
thf(fact_85_nat__power__eq__Suc__0__iff,axiom,(
    ! [X: nat,M: nat] :
      ( ( ( power_power_nat @ X @ M )
        = ( suc @ zero_zero_nat ) )
      = ( ( M = zero_zero_nat )
        | ( X
          = ( suc @ zero_zero_nat ) ) ) ) )).

% nat_power_eq_Suc_0_iff
thf(fact_86_power__Suc__0,axiom,(
    ! [N: nat] :
      ( ( power_power_nat @ ( suc @ zero_zero_nat ) @ N )
      = ( suc @ zero_zero_nat ) ) )).

% power_Suc_0
thf(fact_87_Suc__inject,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) )).

% Suc_inject
thf(fact_88_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_89_exists__least__lemma,axiom,(
    ! [P: nat > $o] :
      ( ~ ( P @ zero_zero_nat )
     => ( ? [X_1: nat] :
            ( P @ X_1 )
       => ? [N2: nat] :
            ( ~ ( P @ N2 )
            & ( P @ ( suc @ N2 ) ) ) ) ) )).

% exists_least_lemma
thf(fact_90_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
     => ? [M2: nat] :
          ( N
          = ( suc @ M2 ) ) ) )).

% not0_implies_Suc
thf(fact_91_old_Onat_Oinducts,axiom,(
    ! [P: nat > $o,Nat: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [Nat3: nat] :
            ( ( P @ Nat3 )
           => ( P @ ( suc @ Nat3 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_92_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y != zero_zero_nat )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) )).

% old.nat.exhaust
thf(fact_93_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_not_Suc
thf(fact_94_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( zero_zero_nat
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_95_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != zero_zero_nat ) )).

% Suc_neq_Zero
thf(fact_96_zero__induct,axiom,(
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ zero_zero_nat ) ) ) )).

% zero_induct
thf(fact_97_diff__induct,axiom,(
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X2: nat] :
          ( P @ X2 @ zero_zero_nat )
     => ( ! [Y2: nat] :
            ( P @ zero_zero_nat @ ( suc @ Y2 ) )
       => ( ! [X2: nat,Y2: nat] :
              ( ( P @ X2 @ Y2 )
             => ( P @ ( suc @ X2 ) @ ( suc @ Y2 ) ) )
         => ( P @ M @ N ) ) ) ) )).

% diff_induct
thf(fact_98_nat__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ( P @ zero_zero_nat )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) )).

% nat_induct
thf(fact_99_nat_OdiscI,axiom,(
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat != zero_zero_nat ) ) )).

% nat.discI
thf(fact_100_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( zero_zero_nat
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_101_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat2: nat] :
      ( ( suc @ Nat2 )
     != zero_zero_nat ) )).

% old.nat.distinct(2)
thf(fact_102_nat_Odistinct_I1_J,axiom,(
    ! [X22: nat] :
      ( zero_zero_nat
     != ( suc @ X22 ) ) )).

% nat.distinct(1)
thf(fact_103_transitive__stepwise__le,axiom,(
    ! [M: nat,N: nat,R: nat > nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ! [X2: nat] :
            ( R @ X2 @ X2 )
       => ( ! [X2: nat,Y2: nat,Z: nat] :
              ( ( R @ X2 @ Y2 )
             => ( ( R @ Y2 @ Z )
               => ( R @ X2 @ Z ) ) )
         => ( ! [N2: nat] :
                ( R @ N2 @ ( suc @ N2 ) )
           => ( R @ M @ N ) ) ) ) ) )).

% transitive_stepwise_le
thf(fact_104_nat__induct__at__least,axiom,(
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N2: nat] :
              ( ( ord_less_eq_nat @ M @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) )).

% nat_induct_at_least
thf(fact_105_full__nat__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_eq_nat @ ( suc @ M3 ) @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% full_nat_induct
thf(fact_106_not__less__eq__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq_nat @ M @ N ) )
      = ( ord_less_eq_nat @ ( suc @ N ) @ M ) ) )).

% not_less_eq_eq
thf(fact_107_Suc__n__not__le__n,axiom,(
    ! [N: nat] :
      ~ ( ord_less_eq_nat @ ( suc @ N ) @ N ) )).

% Suc_n_not_le_n
thf(fact_108_le__Suc__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq_nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) )).

% le_Suc_eq
thf(fact_109_Suc__le__D,axiom,(
    ! [N: nat,M4: nat] :
      ( ( ord_less_eq_nat @ ( suc @ N ) @ M4 )
     => ? [M2: nat] :
          ( M4
          = ( suc @ M2 ) ) ) )).

% Suc_le_D
thf(fact_110_le__SucI,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ N )
     => ( ord_less_eq_nat @ M @ ( suc @ N ) ) ) )).

% le_SucI
thf(fact_111_le__SucE,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq_nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) )).

% le_SucE
thf(fact_112_Suc__leD,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( suc @ M ) @ N )
     => ( ord_less_eq_nat @ M @ N ) ) )).

% Suc_leD
thf(fact_113_fixed__root_Ointro,axiom,(
    ! [P2: nat,Pm: nat] :
      ( ( P2
        = ( suc @ Pm ) )
     => ( nthRoo1352626670d_root @ P2 @ Pm ) ) )).

% fixed_root.intro
thf(fact_114_fixed__root__def,axiom,
    ( nthRoo1352626670d_root
    = ( ^ [P4: nat,Pm2: nat] :
          ( P4
          = ( suc @ Pm2 ) ) ) )).

% fixed_root_def
thf(fact_115_fixed__root_Op,axiom,(
    ! [P2: nat,Pm: nat] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ( P2
        = ( suc @ Pm ) ) ) )).

% fixed_root.p
thf(fact_116_fixed__root_Oroot__newton__int__main_Ocases,axiom,(
    ! [P2: nat,Pm: nat,X: product_prod_int_int] :
      ( ( nthRoo1352626670d_root @ P2 @ Pm )
     => ~ ! [X2: int,N2: int] :
            ( X
           != ( product_Pair_int_int @ X2 @ N2 ) ) ) )).

% fixed_root.root_newton_int_main.cases
thf(fact_117_of__nat__neq__0,axiom,(
    ! [N: nat] :
      ( ( semiri2019852685at_int @ ( suc @ N ) )
     != zero_zero_int ) )).

% of_nat_neq_0
thf(fact_118_of__nat__neq__0,axiom,(
    ! [N: nat] :
      ( ( semiri1382578993at_nat @ ( suc @ N ) )
     != zero_zero_nat ) )).

% of_nat_neq_0
thf(fact_119_lift__Suc__mono__le,axiom,(
    ! [F: nat > int,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_int @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_int @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_le
thf(fact_120_lift__Suc__mono__le,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_nat @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_le
thf(fact_121_lift__Suc__antimono__le,axiom,(
    ! [F: nat > int,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_int @ ( F @ ( suc @ N2 ) ) @ ( F @ N2 ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_int @ ( F @ N3 ) @ ( F @ N ) ) ) ) )).

% lift_Suc_antimono_le
thf(fact_122_lift__Suc__antimono__le,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq_nat @ ( F @ ( suc @ N2 ) ) @ ( F @ N2 ) )
     => ( ( ord_less_eq_nat @ N @ N3 )
       => ( ord_less_eq_nat @ ( F @ N3 ) @ ( F @ N ) ) ) ) )).

% lift_Suc_antimono_le
thf(fact_123_power__inject__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ( power_power_int @ A @ ( suc @ N ) )
        = ( power_power_int @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ A )
       => ( ( ord_less_eq_int @ zero_zero_int @ B )
         => ( A = B ) ) ) ) )).

% power_inject_base
thf(fact_124_power__inject__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ( power_power_nat @ A @ ( suc @ N ) )
        = ( power_power_nat @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ A )
       => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
         => ( A = B ) ) ) ) )).

% power_inject_base
thf(fact_125_power__le__imp__le__base,axiom,(
    ! [A: int,N: nat,B: int] :
      ( ( ord_less_eq_int @ ( power_power_int @ A @ ( suc @ N ) ) @ ( power_power_int @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_int @ zero_zero_int @ B )
       => ( ord_less_eq_int @ A @ B ) ) ) )).

% power_le_imp_le_base
thf(fact_126_power__le__imp__le__base,axiom,(
    ! [A: nat,N: nat,B: nat] :
      ( ( ord_less_eq_nat @ ( power_power_nat @ A @ ( suc @ N ) ) @ ( power_power_nat @ B @ ( suc @ N ) ) )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ord_less_eq_nat @ A @ B ) ) ) )).

% power_le_imp_le_base
thf(fact_127_order__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_128_order__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_eq_int @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_129_order__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_130_order__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_subst1
thf(fact_131_order__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_132_order__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_133_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_int @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_134_order__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_subst2
thf(fact_135_verit__la__disequality,axiom,(
    ! [A: int,B: int] :
      ( ( A = B )
      | ~ ( ord_less_eq_int @ A @ B )
      | ~ ( ord_less_eq_int @ B @ A ) ) )).

% verit_la_disequality
thf(fact_136_verit__la__disequality,axiom,(
    ! [A: nat,B: nat] :
      ( ( A = B )
      | ~ ( ord_less_eq_nat @ A @ B )
      | ~ ( ord_less_eq_nat @ B @ A ) ) )).

% verit_la_disequality
thf(fact_137_ord__eq__le__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_138_ord__eq__le__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_139_ord__eq__le__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_140_ord__eq__le__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_141_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_142_ord__le__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_eq_int @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_143_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_144_ord__le__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_eq_nat @ X2 @ Y2 )
             => ( ord_less_eq_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_eq_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_le_eq_subst
thf(fact_145_eq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [X4: int,Y5: int] :
          ( ( ord_less_eq_int @ X4 @ Y5 )
          & ( ord_less_eq_int @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_146_eq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [X4: nat,Y5: nat] :
          ( ( ord_less_eq_nat @ X4 @ Y5 )
          & ( ord_less_eq_nat @ Y5 @ X4 ) ) ) )).

% eq_iff
thf(fact_147_antisym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_148_antisym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ X )
       => ( X = Y ) ) ) )).

% antisym
thf(fact_149_linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_eq_int @ X @ Y )
      | ( ord_less_eq_int @ Y @ X ) ) )).

% linear
thf(fact_150_linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
      | ( ord_less_eq_nat @ Y @ X ) ) )).

% linear
thf(fact_151_eq__refl,axiom,(
    ! [X: int,Y: int] :
      ( ( X = Y )
     => ( ord_less_eq_int @ X @ Y ) ) )).

% eq_refl
thf(fact_152_eq__refl,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X = Y )
     => ( ord_less_eq_nat @ X @ Y ) ) )).

% eq_refl
thf(fact_153_le__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_eq_int @ X @ Y )
     => ( ord_less_eq_int @ Y @ X ) ) )).

% le_cases
thf(fact_154_le__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_eq_nat @ X @ Y )
     => ( ord_less_eq_nat @ Y @ X ) ) )).

% le_cases
thf(fact_155_order_Otrans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% order.trans
thf(fact_156_order_Otrans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% order.trans
thf(fact_157_le__cases3,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ( ord_less_eq_int @ X @ Y )
       => ~ ( ord_less_eq_int @ Y @ Z3 ) )
     => ( ( ( ord_less_eq_int @ Y @ X )
         => ~ ( ord_less_eq_int @ X @ Z3 ) )
       => ( ( ( ord_less_eq_int @ X @ Z3 )
           => ~ ( ord_less_eq_int @ Z3 @ Y ) )
         => ( ( ( ord_less_eq_int @ Z3 @ Y )
             => ~ ( ord_less_eq_int @ Y @ X ) )
           => ( ( ( ord_less_eq_int @ Y @ Z3 )
               => ~ ( ord_less_eq_int @ Z3 @ X ) )
             => ~ ( ( ord_less_eq_int @ Z3 @ X )
                 => ~ ( ord_less_eq_int @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_158_le__cases3,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ( ord_less_eq_nat @ X @ Y )
       => ~ ( ord_less_eq_nat @ Y @ Z3 ) )
     => ( ( ( ord_less_eq_nat @ Y @ X )
         => ~ ( ord_less_eq_nat @ X @ Z3 ) )
       => ( ( ( ord_less_eq_nat @ X @ Z3 )
           => ~ ( ord_less_eq_nat @ Z3 @ Y ) )
         => ( ( ( ord_less_eq_nat @ Z3 @ Y )
             => ~ ( ord_less_eq_nat @ Y @ X ) )
           => ( ( ( ord_less_eq_nat @ Y @ Z3 )
               => ~ ( ord_less_eq_nat @ Z3 @ X ) )
             => ~ ( ( ord_less_eq_nat @ Z3 @ X )
                 => ~ ( ord_less_eq_nat @ X @ Y ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_159_antisym__conv,axiom,(
    ! [Y: int,X: int] :
      ( ( ord_less_eq_int @ Y @ X )
     => ( ( ord_less_eq_int @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_160_antisym__conv,axiom,(
    ! [Y: nat,X: nat] :
      ( ( ord_less_eq_nat @ Y @ X )
     => ( ( ord_less_eq_nat @ X @ Y )
        = ( X = Y ) ) ) )).

% antisym_conv
thf(fact_161_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ A2 @ B2 )
          & ( ord_less_eq_int @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_162_order__class_Oorder_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ A2 @ B2 )
          & ( ord_less_eq_nat @ B2 @ A2 ) ) ) )).

% order_class.order.eq_iff
thf(fact_163_ord__eq__le__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_eq_int @ B @ C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_164_ord__eq__le__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_eq_nat @ B @ C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_eq_le_trans
thf(fact_165_ord__le__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_int @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_166_ord__le__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_eq_nat @ A @ C ) ) ) )).

% ord_le_eq_trans
thf(fact_167_order__class_Oorder_Oantisym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_eq_int @ A @ B )
     => ( ( ord_less_eq_int @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_168_order__class_Oorder_Oantisym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_eq_nat @ A @ B )
     => ( ( ord_less_eq_nat @ B @ A )
       => ( A = B ) ) ) )).

% order_class.order.antisym
thf(fact_169_order__trans,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ord_less_eq_int @ X @ Y )
     => ( ( ord_less_eq_int @ Y @ Z3 )
       => ( ord_less_eq_int @ X @ Z3 ) ) ) )).

% order_trans
thf(fact_170_order__trans,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ord_less_eq_nat @ X @ Y )
     => ( ( ord_less_eq_nat @ Y @ Z3 )
       => ( ord_less_eq_nat @ X @ Z3 ) ) ) )).

% order_trans
thf(fact_171_dual__order_Orefl,axiom,(
    ! [A: int] :
      ( ord_less_eq_int @ A @ A ) )).

% dual_order.refl
thf(fact_172_dual__order_Orefl,axiom,(
    ! [A: nat] :
      ( ord_less_eq_nat @ A @ A ) )).

% dual_order.refl
thf(fact_173_linorder__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B4: int] :
          ( ( ord_less_eq_int @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: int,B4: int] :
            ( ( P @ B4 @ A4 )
           => ( P @ A4 @ B4 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_174_linorder__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( ord_less_eq_nat @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: nat,B4: nat] :
            ( ( P @ B4 @ A4 )
           => ( P @ A4 @ B4 ) )
       => ( P @ A @ B ) ) ) )).

% linorder_wlog
thf(fact_175_dual__order_Otrans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ C @ B )
       => ( ord_less_eq_int @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_176_dual__order_Otrans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ C @ B )
       => ( ord_less_eq_nat @ C @ A ) ) ) )).

% dual_order.trans
thf(fact_177_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: int,Z2: int] : ( Y4 = Z2 ) )
    = ( ^ [A2: int,B2: int] :
          ( ( ord_less_eq_int @ B2 @ A2 )
          & ( ord_less_eq_int @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_178_dual__order_Oeq__iff,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( ord_less_eq_nat @ B2 @ A2 )
          & ( ord_less_eq_nat @ A2 @ B2 ) ) ) )).

% dual_order.eq_iff
thf(fact_179_dual__order_Oantisym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_eq_int @ B @ A )
     => ( ( ord_less_eq_int @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_180_dual__order_Oantisym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_eq_nat @ B @ A )
     => ( ( ord_less_eq_nat @ A @ B )
       => ( A = B ) ) ) )).

% dual_order.antisym
thf(fact_181_nat__one__le__power,axiom,(
    ! [I: nat,N: nat] :
      ( ( ord_less_eq_nat @ ( suc @ zero_zero_nat ) @ I )
     => ( ord_less_eq_nat @ ( suc @ zero_zero_nat ) @ ( power_power_nat @ I @ N ) ) ) )).

% nat_one_le_power
thf(fact_182_surj__pair,axiom,(
    ! [P2: product_prod_int_o] :
    ? [X2: int,Y2: $o] :
      ( P2
      = ( product_Pair_int_o @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_183_surj__pair,axiom,(
    ! [P2: product_prod_int_int] :
    ? [X2: int,Y2: int] :
      ( P2
      = ( product_Pair_int_int @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_184_prod__cases,axiom,(
    ! [P: product_prod_int_o > $o,P2: product_prod_int_o] :
      ( ! [A4: int,B4: $o] :
          ( P @ ( product_Pair_int_o @ A4 @ B4 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_185_prod__cases,axiom,(
    ! [P: product_prod_int_int > $o,P2: product_prod_int_int] :
      ( ! [A4: int,B4: int] :
          ( P @ ( product_Pair_int_int @ A4 @ B4 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_186_Pair__inject,axiom,(
    ! [A: int,B: $o,A3: int,B3: $o] :
      ( ( ( product_Pair_int_o @ A @ B )
        = ( product_Pair_int_o @ A3 @ B3 ) )
     => ~ ( ( A = A3 )
         => ( B = ( ~ B3 ) ) ) ) )).

% Pair_inject
thf(fact_187_Pair__inject,axiom,(
    ! [A: int,B: int,A3: int,B3: int] :
      ( ( ( product_Pair_int_int @ A @ B )
        = ( product_Pair_int_int @ A3 @ B3 ) )
     => ~ ( ( A = A3 )
         => ( B != B3 ) ) ) )).

% Pair_inject
thf(fact_188_old_Oprod_Oexhaust,axiom,(
    ! [Y: product_prod_int_o] :
      ~ ! [A4: int,B4: $o] :
          ( Y
         != ( product_Pair_int_o @ A4 @ B4 ) ) )).

% old.prod.exhaust
thf(fact_189_old_Oprod_Oexhaust,axiom,(
    ! [Y: product_prod_int_int] :
      ~ ! [A4: int,B4: int] :
          ( Y
         != ( product_Pair_int_int @ A4 @ B4 ) ) )).

% old.prod.exhaust
thf(fact_190_old_Oprod_Oinducts,axiom,(
    ! [P: product_prod_int_o > $o,Prod: product_prod_int_o] :
      ( ! [A4: int,B4: $o] :
          ( P @ ( product_Pair_int_o @ A4 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_191_old_Oprod_Oinducts,axiom,(
    ! [P: product_prod_int_int > $o,Prod: product_prod_int_int] :
      ( ! [A4: int,B4: int] :
          ( P @ ( product_Pair_int_int @ A4 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_192_verit__la__generic,axiom,(
    ! [A: int,X: int] :
      ( ( ord_less_eq_int @ A @ X )
      | ( A = X )
      | ( ord_less_eq_int @ X @ A ) ) )).

% verit_la_generic
thf(fact_193_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y4: nat,Z2: nat] : ( Y4 = Z2 ) )
    = ( ^ [A2: nat,B2: nat] :
          ( ( semiri2019852685at_int @ A2 )
          = ( semiri2019852685at_int @ B2 ) ) ) )).

% nat_int_comparison(1)
thf(fact_194_int__if,axiom,(
    ! [P: $o,A: nat,B: nat] :
      ( ( P
       => ( ( semiri2019852685at_int @ ( if_nat @ P @ A @ B ) )
          = ( semiri2019852685at_int @ A ) ) )
      & ( ~ P
       => ( ( semiri2019852685at_int @ ( if_nat @ P @ A @ B ) )
          = ( semiri2019852685at_int @ B ) ) ) ) )).

% int_if
thf(fact_195_power__mono__iff,axiom,(
    ! [A: int,B: int,N: nat] :
      ( ( ord_less_eq_int @ zero_zero_int @ A )
     => ( ( ord_less_eq_int @ zero_zero_int @ B )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ( ord_less_eq_int @ ( power_power_int @ A @ N ) @ ( power_power_int @ B @ N ) )
            = ( ord_less_eq_int @ A @ B ) ) ) ) ) )).

% power_mono_iff
thf(fact_196_power__mono__iff,axiom,(
    ! [A: nat,B: nat,N: nat] :
      ( ( ord_less_eq_nat @ zero_zero_nat @ A )
     => ( ( ord_less_eq_nat @ zero_zero_nat @ B )
       => ( ( ord_less_nat @ zero_zero_nat @ N )
         => ( ( ord_less_eq_nat @ ( power_power_nat @ A @ N ) @ ( power_power_nat @ B @ N ) )
            = ( ord_less_eq_nat @ A @ B ) ) ) ) ) )).

% power_mono_iff
thf(fact_197_of__int__le__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_eq_int @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) @ ( ring_1_of_int_int @ X ) )
      = ( ord_less_eq_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_le_of_int_power_cancel_iff
thf(fact_198_of__int__power__le__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ X ) @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) )
      = ( ord_less_eq_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_le_of_int_cancel_iff
thf(fact_199_of__int__0__le__iff,axiom,(
    ! [Z3: int] :
      ( ( ord_less_eq_int @ zero_zero_int @ ( ring_1_of_int_int @ Z3 ) )
      = ( ord_less_eq_int @ zero_zero_int @ Z3 ) ) )).

% of_int_0_le_iff
thf(fact_200_of__int__eq__iff,axiom,(
    ! [W: int,Z3: int] :
      ( ( ( ring_1_of_int_int @ W )
        = ( ring_1_of_int_int @ Z3 ) )
      = ( W = Z3 ) ) )).

% of_int_eq_iff
thf(fact_201_not__gr__zero,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less_nat @ zero_zero_nat @ N ) )
      = ( N = zero_zero_nat ) ) )).

% not_gr_zero
thf(fact_202_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% neq0_conv
thf(fact_203_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ zero_zero_nat ) )).

% less_nat_zero_code
thf(fact_204_bot__nat__0_Onot__eq__extremum,axiom,(
    ! [A: nat] :
      ( ( A != zero_zero_nat )
      = ( ord_less_nat @ zero_zero_nat @ A ) ) )).

% bot_nat_0.not_eq_extremum
thf(fact_205_Suc__less__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% Suc_less_eq
thf(fact_206_Suc__mono,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ ( suc @ M ) @ ( suc @ N ) ) ) )).

% Suc_mono
thf(fact_207_lessI,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ N @ ( suc @ N ) ) )).

% lessI
thf(fact_208_of__int__less__iff,axiom,(
    ! [W: int,Z3: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z3 ) )
      = ( ord_less_int @ W @ Z3 ) ) )).

% of_int_less_iff
thf(fact_209_of__nat__less__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_int @ ( semiri2019852685at_int @ M ) @ ( semiri2019852685at_int @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% of_nat_less_iff
thf(fact_210_of__nat__less__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( semiri1382578993at_nat @ M ) @ ( semiri1382578993at_nat @ N ) )
      = ( ord_less_nat @ M @ N ) ) )).

% of_nat_less_iff
thf(fact_211_less__Suc0,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ N @ ( suc @ zero_zero_nat ) )
      = ( N = zero_zero_nat ) ) )).

% less_Suc0
thf(fact_212_zero__less__Suc,axiom,(
    ! [N: nat] :
      ( ord_less_nat @ zero_zero_nat @ ( suc @ N ) ) )).

% zero_less_Suc
thf(fact_213_of__int__eq__0__iff,axiom,(
    ! [Z3: int] :
      ( ( ( ring_1_of_int_int @ Z3 )
        = zero_zero_int )
      = ( Z3 = zero_zero_int ) ) )).

% of_int_eq_0_iff
thf(fact_214_of__int__0__eq__iff,axiom,(
    ! [Z3: int] :
      ( ( zero_zero_int
        = ( ring_1_of_int_int @ Z3 ) )
      = ( Z3 = zero_zero_int ) ) )).

% of_int_0_eq_iff
thf(fact_215_of__int__0,axiom,
    ( ( ring_1_of_int_int @ zero_zero_int )
    = zero_zero_int )).

% of_int_0
thf(fact_216_of__int__le__iff,axiom,(
    ! [W: int,Z3: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ W ) @ ( ring_1_of_int_int @ Z3 ) )
      = ( ord_less_eq_int @ W @ Z3 ) ) )).

% of_int_le_iff
thf(fact_217_of__int__of__nat__eq,axiom,(
    ! [N: nat] :
      ( ( ring_1_of_int_int @ ( semiri2019852685at_int @ N ) )
      = ( semiri2019852685at_int @ N ) ) )).

% of_int_of_nat_eq
thf(fact_218_nat__zero__less__power__iff,axiom,(
    ! [X: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ X @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N = zero_zero_nat ) ) ) )).

% nat_zero_less_power_iff
thf(fact_219_of__int__power__eq__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ( ring_1_of_int_int @ X )
        = ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) )
      = ( X
        = ( power_power_int @ B @ W ) ) ) )).

% of_int_power_eq_of_int_cancel_iff
thf(fact_220_of__int__eq__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ( power_power_int @ ( ring_1_of_int_int @ B ) @ W )
        = ( ring_1_of_int_int @ X ) )
      = ( ( power_power_int @ B @ W )
        = X ) ) )).

% of_int_eq_of_int_power_cancel_iff
thf(fact_221_of__int__power,axiom,(
    ! [Z3: int,N: nat] :
      ( ( ring_1_of_int_int @ ( power_power_int @ Z3 @ N ) )
      = ( power_power_int @ ( ring_1_of_int_int @ Z3 ) @ N ) ) )).

% of_int_power
thf(fact_222_power__eq__0__iff,axiom,(
    ! [A: int,N: nat] :
      ( ( ( power_power_int @ A @ N )
        = zero_zero_int )
      = ( ( A = zero_zero_int )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% power_eq_0_iff
thf(fact_223_power__eq__0__iff,axiom,(
    ! [A: nat,N: nat] :
      ( ( ( power_power_nat @ A @ N )
        = zero_zero_nat )
      = ( ( A = zero_zero_nat )
        & ( ord_less_nat @ zero_zero_nat @ N ) ) ) )).

% power_eq_0_iff
thf(fact_224_of__int__0__less__iff,axiom,(
    ! [Z3: int] :
      ( ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z3 ) )
      = ( ord_less_int @ zero_zero_int @ Z3 ) ) )).

% of_int_0_less_iff
thf(fact_225_of__int__less__0__iff,axiom,(
    ! [Z3: int] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ Z3 ) @ zero_zero_int )
      = ( ord_less_int @ Z3 @ zero_zero_int ) ) )).

% of_int_less_0_iff
thf(fact_226_of__int__less__of__int__power__cancel__iff,axiom,(
    ! [B: int,W: nat,X: int] :
      ( ( ord_less_int @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) @ ( ring_1_of_int_int @ X ) )
      = ( ord_less_int @ ( power_power_int @ B @ W ) @ X ) ) )).

% of_int_less_of_int_power_cancel_iff
thf(fact_227_of__int__power__less__of__int__cancel__iff,axiom,(
    ! [X: int,B: int,W: nat] :
      ( ( ord_less_int @ ( ring_1_of_int_int @ X ) @ ( power_power_int @ ( ring_1_of_int_int @ B ) @ W ) )
      = ( ord_less_int @ X @ ( power_power_int @ B @ W ) ) ) )).

% of_int_power_less_of_int_cancel_iff
thf(fact_228_of__nat__0__less__iff,axiom,(
    ! [N: nat] :
      ( ( ord_less_int @ zero_zero_int @ ( semiri2019852685at_int @ N ) )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% of_nat_0_less_iff
thf(fact_229_of__nat__0__less__iff,axiom,(
    ! [N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( semiri1382578993at_nat @ N ) )
      = ( ord_less_nat @ zero_zero_nat @ N ) ) )).

% of_nat_0_less_iff
thf(fact_230_of__int__le__0__iff,axiom,(
    ! [Z3: int] :
      ( ( ord_less_eq_int @ ( ring_1_of_int_int @ Z3 ) @ zero_zero_int )
      = ( ord_less_eq_int @ Z3 @ zero_zero_int ) ) )).

% of_int_le_0_iff
thf(fact_231_of__nat__power__less__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ord_less_int @ ( semiri2019852685at_int @ X ) @ ( power_power_int @ ( semiri2019852685at_int @ B ) @ W ) )
      = ( ord_less_nat @ X @ ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_232_of__nat__power__less__of__nat__cancel__iff,axiom,(
    ! [X: nat,B: nat,W: nat] :
      ( ( ord_less_nat @ ( semiri1382578993at_nat @ X ) @ ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W ) )
      = ( ord_less_nat @ X @ ( power_power_nat @ B @ W ) ) ) )).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_233_of__nat__less__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ord_less_int @ ( power_power_int @ ( semiri2019852685at_int @ B ) @ W ) @ ( semiri2019852685at_int @ X ) )
      = ( ord_less_nat @ ( power_power_nat @ B @ W ) @ X ) ) )).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_234_of__nat__less__of__nat__power__cancel__iff,axiom,(
    ! [B: nat,W: nat,X: nat] :
      ( ( ord_less_nat @ ( power_power_nat @ ( semiri1382578993at_nat @ B ) @ W ) @ ( semiri1382578993at_nat @ X ) )
      = ( ord_less_nat @ ( power_power_nat @ B @ W ) @ X ) ) )).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_235_of__nat__zero__less__power__iff,axiom,(
    ! [X: nat,N: nat] :
      ( ( ord_less_int @ zero_zero_int @ ( power_power_int @ ( semiri2019852685at_int @ X ) @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N = zero_zero_nat ) ) ) )).

% of_nat_zero_less_power_iff
thf(fact_236_of__nat__zero__less__power__iff,axiom,(
    ! [X: nat,N: nat] :
      ( ( ord_less_nat @ zero_zero_nat @ ( power_power_nat @ ( semiri1382578993at_nat @ X ) @ N ) )
      = ( ( ord_less_nat @ zero_zero_nat @ X )
        | ( N = zero_zero_nat ) ) ) )).

% of_nat_zero_less_power_iff
thf(fact_237_lift__Suc__mono__less,axiom,(
    ! [F: nat > int,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_int @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ N @ N3 )
       => ( ord_less_int @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_238_lift__Suc__mono__less,axiom,(
    ! [F: nat > nat,N: nat,N3: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ N @ N3 )
       => ( ord_less_nat @ ( F @ N ) @ ( F @ N3 ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_239_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > int,N: nat,M: nat] :
      ( ! [N2: nat] :
          ( ord_less_int @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_int @ ( F @ N ) @ ( F @ M ) )
        = ( ord_less_nat @ N @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_240_lift__Suc__mono__less__iff,axiom,(
    ! [F: nat > nat,N: nat,M: nat] :
      ( ! [N2: nat] :
          ( ord_less_nat @ ( F @ N2 ) @ ( F @ ( suc @ N2 ) ) )
     => ( ( ord_less_nat @ ( F @ N ) @ ( F @ M ) )
        = ( ord_less_nat @ N @ M ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_241_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_242_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( A != B ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_243_order_Ostrict__implies__not__eq,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_244_order_Ostrict__implies__not__eq,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( A != B ) ) )).

% order.strict_implies_not_eq
thf(fact_245_not__less__iff__gr__or__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ~ ( ord_less_int @ X @ Y ) )
      = ( ( ord_less_int @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_246_not__less__iff__gr__or__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ~ ( ord_less_nat @ X @ Y ) )
      = ( ( ord_less_nat @ Y @ X )
        | ( X = Y ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_247_dual__order_Ostrict__trans,axiom,(
    ! [B: int,A: int,C: int] :
      ( ( ord_less_int @ B @ A )
     => ( ( ord_less_int @ C @ B )
       => ( ord_less_int @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_248_dual__order_Ostrict__trans,axiom,(
    ! [B: nat,A: nat,C: nat] :
      ( ( ord_less_nat @ B @ A )
     => ( ( ord_less_nat @ C @ B )
       => ( ord_less_nat @ C @ A ) ) ) )).

% dual_order.strict_trans
thf(fact_249_linorder__less__wlog,axiom,(
    ! [P: int > int > $o,A: int,B: int] :
      ( ! [A4: int,B4: int] :
          ( ( ord_less_int @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: int] :
            ( P @ A4 @ A4 )
       => ( ! [A4: int,B4: int] :
              ( ( P @ B4 @ A4 )
             => ( P @ A4 @ B4 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_250_linorder__less__wlog,axiom,(
    ! [P: nat > nat > $o,A: nat,B: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( ord_less_nat @ A4 @ B4 )
         => ( P @ A4 @ B4 ) )
     => ( ! [A4: nat] :
            ( P @ A4 @ A4 )
       => ( ! [A4: nat,B4: nat] :
              ( ( P @ B4 @ A4 )
             => ( P @ A4 @ B4 ) )
         => ( P @ A @ B ) ) ) ) )).

% linorder_less_wlog
thf(fact_251_exists__least__iff,axiom,
    ( ( ^ [P5: nat > $o] :
        ? [X5: nat] :
          ( P5 @ X5 ) )
    = ( ^ [P6: nat > $o] :
        ? [N4: nat] :
          ( ( P6 @ N4 )
          & ! [M5: nat] :
              ( ( ord_less_nat @ M5 @ N4 )
             => ~ ( P6 @ M5 ) ) ) ) )).

% exists_least_iff
thf(fact_252_less__imp__not__less,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_253_less__imp__not__less,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_imp_not_less
thf(fact_254_order_Ostrict__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_255_order_Ostrict__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% order.strict_trans
thf(fact_256_dual__order_Oirrefl,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% dual_order.irrefl
thf(fact_257_dual__order_Oirrefl,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% dual_order.irrefl
thf(fact_258_linorder__cases,axiom,(
    ! [X: int,Y: int] :
      ( ~ ( ord_less_int @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_259_linorder__cases,axiom,(
    ! [X: nat,Y: nat] :
      ( ~ ( ord_less_nat @ X @ Y )
     => ( ( X != Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_cases
thf(fact_260_less__imp__triv,axiom,(
    ! [X: int,Y: int,P: $o] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_261_less__imp__triv,axiom,(
    ! [X: nat,Y: nat,P: $o] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ X )
       => P ) ) )).

% less_imp_triv
thf(fact_262_less__imp__not__eq2,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_263_less__imp__not__eq2,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( Y != X ) ) )).

% less_imp_not_eq2
thf(fact_264_antisym__conv3,axiom,(
    ! [Y: int,X: int] :
      ( ~ ( ord_less_int @ Y @ X )
     => ( ( ~ ( ord_less_int @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_265_antisym__conv3,axiom,(
    ! [Y: nat,X: nat] :
      ( ~ ( ord_less_nat @ Y @ X )
     => ( ( ~ ( ord_less_nat @ X @ Y ) )
        = ( X = Y ) ) ) )).

% antisym_conv3
thf(fact_266_less__induct,axiom,(
    ! [P: nat > $o,A: nat] :
      ( ! [X2: nat] :
          ( ! [Y3: nat] :
              ( ( ord_less_nat @ Y3 @ X2 )
             => ( P @ Y3 ) )
         => ( P @ X2 ) )
     => ( P @ A ) ) )).

% less_induct
thf(fact_267_less__not__sym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_not_sym
thf(fact_268_less__not__sym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_not_sym
thf(fact_269_less__imp__not__eq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_270_less__imp__not__eq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_not_eq
thf(fact_271_dual__order_Oasym,axiom,(
    ! [B: int,A: int] :
      ( ( ord_less_int @ B @ A )
     => ~ ( ord_less_int @ A @ B ) ) )).

% dual_order.asym
thf(fact_272_dual__order_Oasym,axiom,(
    ! [B: nat,A: nat] :
      ( ( ord_less_nat @ B @ A )
     => ~ ( ord_less_nat @ A @ B ) ) )).

% dual_order.asym
thf(fact_273_ord__less__eq__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( B = C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_274_ord__less__eq__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( B = C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_less_eq_trans
thf(fact_275_ord__eq__less__trans,axiom,(
    ! [A: int,B: int,C: int] :
      ( ( A = B )
     => ( ( ord_less_int @ B @ C )
       => ( ord_less_int @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_276_ord__eq__less__trans,axiom,(
    ! [A: nat,B: nat,C: nat] :
      ( ( A = B )
     => ( ( ord_less_nat @ B @ C )
       => ( ord_less_nat @ A @ C ) ) ) )).

% ord_eq_less_trans
thf(fact_277_less__irrefl,axiom,(
    ! [X: int] :
      ~ ( ord_less_int @ X @ X ) )).

% less_irrefl
thf(fact_278_less__irrefl,axiom,(
    ! [X: nat] :
      ~ ( ord_less_nat @ X @ X ) )).

% less_irrefl
thf(fact_279_less__linear,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
      | ( X = Y )
      | ( ord_less_int @ Y @ X ) ) )).

% less_linear
thf(fact_280_less__linear,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
      | ( X = Y )
      | ( ord_less_nat @ Y @ X ) ) )).

% less_linear
thf(fact_281_less__trans,axiom,(
    ! [X: int,Y: int,Z3: int] :
      ( ( ord_less_int @ X @ Y )
     => ( ( ord_less_int @ Y @ Z3 )
       => ( ord_less_int @ X @ Z3 ) ) ) )).

% less_trans
thf(fact_282_less__trans,axiom,(
    ! [X: nat,Y: nat,Z3: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( ( ord_less_nat @ Y @ Z3 )
       => ( ord_less_nat @ X @ Z3 ) ) ) )).

% less_trans
thf(fact_283_less__asym_H,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% less_asym'
thf(fact_284_less__asym_H,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% less_asym'
thf(fact_285_less__asym,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ~ ( ord_less_int @ Y @ X ) ) )).

% less_asym
thf(fact_286_less__asym,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ~ ( ord_less_nat @ Y @ X ) ) )).

% less_asym
thf(fact_287_less__imp__neq,axiom,(
    ! [X: int,Y: int] :
      ( ( ord_less_int @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_288_less__imp__neq,axiom,(
    ! [X: nat,Y: nat] :
      ( ( ord_less_nat @ X @ Y )
     => ( X != Y ) ) )).

% less_imp_neq
thf(fact_289_order_Oasym,axiom,(
    ! [A: int,B: int] :
      ( ( ord_less_int @ A @ B )
     => ~ ( ord_less_int @ B @ A ) ) )).

% order.asym
thf(fact_290_order_Oasym,axiom,(
    ! [A: nat,B: nat] :
      ( ( ord_less_nat @ A @ B )
     => ~ ( ord_less_nat @ B @ A ) ) )).

% order.asym
thf(fact_291_neq__iff,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
      = ( ( ord_less_int @ X @ Y )
        | ( ord_less_int @ Y @ X ) ) ) )).

% neq_iff
thf(fact_292_neq__iff,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
      = ( ( ord_less_nat @ X @ Y )
        | ( ord_less_nat @ Y @ X ) ) ) )).

% neq_iff
thf(fact_293_neqE,axiom,(
    ! [X: int,Y: int] :
      ( ( X != Y )
     => ( ~ ( ord_less_int @ X @ Y )
       => ( ord_less_int @ Y @ X ) ) ) )).

% neqE
thf(fact_294_neqE,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% neqE
thf(fact_295_gt__ex,axiom,(
    ! [X: int] :
    ? [X_12: int] :
      ( ord_less_int @ X @ X_12 ) )).

% gt_ex
thf(fact_296_gt__ex,axiom,(
    ! [X: nat] :
    ? [X_12: nat] :
      ( ord_less_nat @ X @ X_12 ) )).

% gt_ex
thf(fact_297_lt__ex,axiom,(
    ! [X: int] :
    ? [Y2: int] :
      ( ord_less_int @ Y2 @ X ) )).

% lt_ex
thf(fact_298_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_299_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_300_order__less__subst2,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ord_less_int @ ( F @ B ) @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_301_order__less__subst2,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ord_less_nat @ ( F @ B ) @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% order_less_subst2
thf(fact_302_order__less__subst1,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_303_order__less__subst1,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_304_order__less__subst1,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( ord_less_int @ A @ ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_305_order__less__subst1,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( ord_less_nat @ A @ ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% order_less_subst1
thf(fact_306_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > int,C: int] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_307_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > nat,C: nat] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_308_ord__less__eq__subst,axiom,(
    ! [A: int,B: int,F: int > int,C: int] :
      ( ( ord_less_int @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_309_ord__less__eq__subst,axiom,(
    ! [A: nat,B: nat,F: nat > nat,C: nat] :
      ( ( ord_less_nat @ A @ B )
     => ( ( ( F @ B )
          = C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ ( F @ A ) @ C ) ) ) ) )).

% ord_less_eq_subst
thf(fact_310_ord__eq__less__subst,axiom,(
    ! [A: int,F: nat > int,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_311_ord__eq__less__subst,axiom,(
    ! [A: nat,F: int > nat,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_312_ord__eq__less__subst,axiom,(
    ! [A: int,F: int > int,B: int,C: int] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_int @ B @ C )
       => ( ! [X2: int,Y2: int] :
              ( ( ord_less_int @ X2 @ Y2 )
             => ( ord_less_int @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_int @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_313_ord__eq__less__subst,axiom,(
    ! [A: nat,F: nat > nat,B: nat,C: nat] :
      ( ( A
        = ( F @ B ) )
     => ( ( ord_less_nat @ B @ C )
       => ( ! [X2: nat,Y2: nat] :
              ( ( ord_less_nat @ X2 @ Y2 )
             => ( ord_less_nat @ ( F @ X2 ) @ ( F @ Y2 ) ) )
         => ( ord_less_nat @ A @ ( F @ C ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_314_verit__comp__simplify1_I1_J,axiom,(
    ! [A: int] :
      ~ ( ord_less_int @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_315_verit__comp__simplify1_I1_J,axiom,(
    ! [A: nat] :
      ~ ( ord_less_nat @ A @ A ) )).

% verit_comp_simplify1(1)
thf(fact_316_pinf_I1_J,axiom,(
    ! [P: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X2: int] :
          ( ( ord_less_int @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less_int @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: int] :
          ! [X6: int] :
            ( ( ord_less_int @ Z @ X6 )
           => ( ( ( P @ X6 )
                & ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                & ( Q2 @ X6 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_317_pinf_I1_J,axiom,(
    ! [P: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: nat] :
          ! [X6: nat] :
            ( ( ord_less_nat @ Z @ X6 )
           => ( ( ( P @ X6 )
                & ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                & ( Q2 @ X6 ) ) ) ) ) ) )).

% pinf(1)
thf(fact_318_pinf_I2_J,axiom,(
    ! [P: int > $o,P3: int > $o,Q: int > $o,Q2: int > $o] :
      ( ? [Z4: int] :
        ! [X2: int] :
          ( ( ord_less_int @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: int] :
          ! [X2: int] :
            ( ( ord_less_int @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: int] :
          ! [X6: int] :
            ( ( ord_less_int @ Z @ X6 )
           => ( ( ( P @ X6 )
                | ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                | ( Q2 @ X6 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_319_pinf_I2_J,axiom,(
    ! [P: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ Z4 @ X2 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ Z4 @ X2 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: nat] :
          ! [X6: nat] :
            ( ( ord_less_nat @ Z @ X6 )
           => ( ( ( P @ X6 )
                | ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                | ( Q2 @ X6 ) ) ) ) ) ) )).

% pinf(2)
thf(fact_320_pinf_I3_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X6: int] :
      ( ( ord_less_int @ Z @ X6 )
     => ( X6 != T ) ) )).

% pinf(3)
thf(fact_321_pinf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z @ X6 )
     => ( X6 != T ) ) )).

% pinf(3)
thf(fact_322_pinf_I4_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X6: int] :
      ( ( ord_less_int @ Z @ X6 )
     => ( X6 != T ) ) )).

% pinf(4)
thf(fact_323_pinf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z @ X6 )
     => ( X6 != T ) ) )).

% pinf(4)
thf(fact_324_pinf_I5_J,axiom,(
    ! [T: int] :
    ? [Z: int] :
    ! [X6: int] :
      ( ( ord_less_int @ Z @ X6 )
     => ~ ( ord_less_int @ X6 @ T ) ) )).

% pinf(5)
thf(fact_325_pinf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z @ X6 )
     => ~ ( ord_less_nat @ X6 @ T ) ) )).

% pinf(5)
thf(fact_326_pinf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ Z @ X6 )
     => ( ord_less_nat @ T @ X6 ) ) )).

% pinf(7)
thf(fact_327_minf_I1_J,axiom,(
    ! [P: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: nat] :
          ! [X6: nat] :
            ( ( ord_less_nat @ X6 @ Z )
           => ( ( ( P @ X6 )
                & ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                & ( Q2 @ X6 ) ) ) ) ) ) )).

% minf(1)
thf(fact_328_minf_I2_J,axiom,(
    ! [P: nat > $o,P3: nat > $o,Q: nat > $o,Q2: nat > $o] :
      ( ? [Z4: nat] :
        ! [X2: nat] :
          ( ( ord_less_nat @ X2 @ Z4 )
         => ( ( P @ X2 )
            = ( P3 @ X2 ) ) )
     => ( ? [Z4: nat] :
          ! [X2: nat] :
            ( ( ord_less_nat @ X2 @ Z4 )
           => ( ( Q @ X2 )
              = ( Q2 @ X2 ) ) )
       => ? [Z: nat] :
          ! [X6: nat] :
            ( ( ord_less_nat @ X6 @ Z )
           => ( ( ( P @ X6 )
                | ( Q @ X6 ) )
              = ( ( P3 @ X6 )
                | ( Q2 @ X6 ) ) ) ) ) ) )).

% minf(2)
thf(fact_329_minf_I3_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ X6 @ Z )
     => ( X6 != T ) ) )).

% minf(3)
thf(fact_330_minf_I4_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ X6 @ Z )
     => ( X6 != T ) ) )).

% minf(4)
thf(fact_331_minf_I5_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ X6 @ Z )
     => ( ord_less_nat @ X6 @ T ) ) )).

% minf(5)
thf(fact_332_minf_I7_J,axiom,(
    ! [T: nat] :
    ? [Z: nat] :
    ! [X6: nat] :
      ( ( ord_less_nat @ X6 @ Z )
     => ~ ( ord_less_nat @ T @ X6 ) ) )).

% minf(7)
thf(fact_333_of__nat__less__imp__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_int @ ( semiri2019852685at_int @ M ) @ ( semiri2019852685at_int @ N ) )
     => ( ord_less_nat @ M @ N ) ) )).

% of_nat_less_imp_less
thf(fact_334_of__nat__less__imp__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ ( semiri1382578993at_nat @ M ) @ ( semiri1382578993at_nat @ N ) )
     => ( ord_less_nat @ M @ N ) ) )).

% of_nat_less_imp_less
thf(fact_335_less__imp__of__nat__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_int @ ( semiri2019852685at_int @ M ) @ ( semiri2019852685at_int @ N ) ) ) )).

% less_imp_of_nat_less
thf(fact_336_less__imp__of__nat__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_nat @ M @ N )
     => ( ord_less_nat @ ( semiri1382578993at_nat @ M ) @ ( semiri1382578993at_nat @ N ) ) ) )).

% less_imp_of_nat_less
thf(fact_337_of__int__pos,axiom,(
    ! [Z3: int] :
      ( ( ord_less_int @ zero_zero_int @ Z3 )
     => ( ord_less_int @ zero_zero_int @ ( ring_1_of_int_int @ Z3 ) ) ) )).

% of_int_pos
thf(fact_338_of__nat__less__of__int__iff,axiom,(
    ! [N: nat,X: int] :
      ( ( ord_less_int @ ( semiri2019852685at_int @ N ) @ ( ring_1_of_int_int @ X ) )
      = ( ord_less_int @ ( semiri2019852685at_int @ N ) @ X ) ) )).

% of_nat_less_of_int_iff
thf(fact_339_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less_nat @ X @ Y )
       => ( ord_less_nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_340_infinite__descent,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M3: nat] :
              ( ( ord_less_nat @ M3 @ N2 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_341_nat__less__induct,axiom,(
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less_nat @ M3 @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_342_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_343_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less_nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_344_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less_nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_345_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less_nat @ N @ N ) )).

% less_not_refl

% Helper facts (3)
thf(help_If_3_1_If_001t__Nat__Onat_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_If_001t__Nat__Onat_T,axiom,(
    ! [X: nat,Y: nat] :
      ( ( if_nat @ $true @ X @ Y )
      = X ) )).

% Conjectures (4)
thf(conj_0,hypothesis,(
    ord_less_eq_int @ zero_zero_int @ x )).

thf(conj_1,hypothesis,(
    ord_less_eq_int @ zero_zero_int @ n )).

thf(conj_2,hypothesis,
    ( ( nthRoo2086695111t_main @ pm @ ( semiri2019852685at_int @ pm ) @ ( semiri2019852685at_int @ p ) @ x @ n )
    = ( product_Pair_int_o @ y @ b ) )).

thf(conj_3,conjecture,(
    ord_less_eq_int @ ( power_power_int @ y @ p ) @ n )).

%------------------------------------------------------------------------------
